using System;
namespace Volpe.Cafe.Optimization.Data
{
    [Serializable]
    public class IterationData
    {
        #region 
        public void Reset()
        {
            this.Valid = false;
            if (this.Coefficients != null) { Array.Clear(this.Coefficients, 0, this.Coefficients.Length); }
            this.Standard                = 0;
            this.CAFE                    = 0;
            this.TotalSocialCosts        = 0;
            this.TotalSocialBenefits     = 0;
            this.TotalSocialBenefitsDisc = 0;
            this.FuelSavings             = 0;
            this.NetBenefits             = 0;
        }
        #endregion
        #region 
        public bool Valid;
        public double[] Coefficients;
        public double Standard;
        public double CAFE;
        public double TotalSocialCosts;
        public double TotalSocialBenefits;
        public double TotalSocialBenefitsDisc;
        public double FuelSavings;
        public double NetBenefits;
        #endregion
    }
}

