#region << Using Directives >>
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Volpe.Cafe.Data;
using Volpe.Cafe.Model;
using Volpe.Cafe.MonteCarlo.Model;
using Volpe.Cafe.MonteCarlo.Settings;
using Volpe.Cafe.Settings;
using Volpe.Cafe.UI.Panels;
#endregion
namespace Volpe.Cafe.UI
{
    public class ManageMonteCarlo : Form
    {
        #region 
        public ManageMonteCarlo(Session session)
        {
            this.InitializeComponent();
            this._session = session;
            this._isMC = (this._session.Compliance is MonteCarloModel);
        }
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }
        #endregion
        #region 
        #region 
        void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ManageMonteCarlo));
            this.ux_statusTextBox = new System.Windows.Forms.RichTextBox();
            this.ux_close = new System.Windows.Forms.Button();
            this.ux_save = new System.Windows.Forms.Button();
            this.ux_monteCarloPanel = new Volpe.Cafe.UI.Panels.MonteCarloPanel();
            this.SuspendLayout();
            this.ux_statusTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_statusTextBox.BackColor = System.Drawing.SystemColors.Control;
            this.ux_statusTextBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.ux_statusTextBox.Enabled = false;
            this.ux_statusTextBox.ForeColor = System.Drawing.Color.Black;
            this.ux_statusTextBox.Location = new System.Drawing.Point(8, 389);
            this.ux_statusTextBox.Name = "ux_statusTextBox";
            this.ux_statusTextBox.ReadOnly = true;
            this.ux_statusTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Vertical;
            this.ux_statusTextBox.Size = new System.Drawing.Size(344, 56);
            this.ux_statusTextBox.TabIndex = 1;
            this.ux_statusTextBox.TabStop = false;
            this.ux_statusTextBox.Text = "";
            this.ux_close.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_close.BackColor = System.Drawing.SystemColors.Control;
            this.ux_close.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.ux_close.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_close.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_close.ForeColor = System.Drawing.Color.Red;
            this.ux_close.Location = new System.Drawing.Point(416, 389);
            this.ux_close.Name = "ux_close";
            this.ux_close.Size = new System.Drawing.Size(48, 48);
            this.ux_close.TabIndex = 3;
            this.ux_close.Text = "Close";
            this.ux_close.UseVisualStyleBackColor = false;
            this.ux_close.Click += new System.EventHandler(this.Close_Click);
            this.ux_save.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_save.BackColor = System.Drawing.SystemColors.Control;
            this.ux_save.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_save.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_save.ForeColor = System.Drawing.Color.Green;
            this.ux_save.Location = new System.Drawing.Point(360, 389);
            this.ux_save.Name = "ux_save";
            this.ux_save.Size = new System.Drawing.Size(48, 48);
            this.ux_save.TabIndex = 2;
            this.ux_save.Text = "Save";
            this.ux_save.UseVisualStyleBackColor = false;
            this.ux_save.Click += new System.EventHandler(this.Save_Click);
            this.ux_monteCarloPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_monteCarloPanel.AutoScroll = true;
            this.ux_monteCarloPanel.Location = new System.Drawing.Point(16, 16);
            this.ux_monteCarloPanel.MinimumSize = new System.Drawing.Size(440, 0);
            this.ux_monteCarloPanel.Name = "ux_monteCarloPanel";
            this.ux_monteCarloPanel.Size = new System.Drawing.Size(440, 194);
            this.ux_monteCarloPanel.TabIndex = 0;
            this.ux_monteCarloPanel.Visible = false;
            this.AcceptButton = this.ux_save;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.ux_close;
            this.ClientSize = new System.Drawing.Size(474, 452);
            this.Controls.Add(this.ux_close);
            this.Controls.Add(this.ux_save);
            this.Controls.Add(this.ux_monteCarloPanel);
            this.Controls.Add(this.ux_statusTextBox);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.MinimumSize = new System.Drawing.Size(480, 480);
            this.Name = "ManageMonteCarlo";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Manage Monte-Carlo";
            this.ResumeLayout(false);
        }
        #endregion
        #region 
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (this._isMC)
            {   
                this.ux_monteCarloPanel.Messages.MessagesChanged += new EventHandler(this.Messages_MessagesChanged);
                this.ux_monteCarloPanel.SetInitialState((MonteCarloSettings)this._session.Settings.GetRuntimeSettings(typeof(MonteCarloSettings)));
                this.ux_monteCarloPanel.Location = new Point(0, 0);
                this.ux_monteCarloPanel.Size = PreferredMCPanelSize;
                this.ux_monteCarloPanel.Visible = true;
            }
            else
            {   
                Label warningLabel = new Label();
                warningLabel.Location = new Point(0, 0);
                warningLabel.Size = PreferredMCPanelSize;
                warningLabel.Font = new Font(this.Font.FontFamily, 14);
                warningLabel.ForeColor = Color.Red;
                warningLabel.TextAlign = ContentAlignment.MiddleCenter;
                warningLabel.Text = "No valid Monte-Carlo model selected.";
                this.Controls.Add(warningLabel);
            }
            Application.Idle += new EventHandler(this.ManageMonteCarlo_Idle);
            this.ux_save.Visible = !this._session.Running;
        }
        protected override void OnClosing(CancelEventArgs e)
        {
            if (this._isMC) { this.ux_monteCarloPanel.Messages.MessagesChanged -= new EventHandler(this.Messages_MessagesChanged); }
            Application.Idle -= new EventHandler(this.ManageMonteCarlo_Idle);
            base.OnClosing(e);
        }
        #endregion
        void ManageMonteCarlo_Idle(object sender, EventArgs e)
        {
            this.ux_save.Enabled = !this._session.Running && (this._isMC && this.ux_monteCarloPanel.SettingsChanged);
        }
        void Messages_MessagesChanged(object sender, EventArgs e)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new EventHandler(this.Messages_MessagesChanged));
            }
            else
            {
                string messages = (this._isMC) ? this.ux_monteCarloPanel.Messages.ToString() : string.Empty;
                this.ux_statusTextBox.Text      = messages;
                this.ux_statusTextBox.ForeColor = Color.Red;
                this.ux_statusTextBox.Enabled   = this.ux_statusTextBox.Text != string.Empty;
            }
        }
        void Save_Click(object sender, System.EventArgs e)
        {
            if (this._isMC) { this.ux_monteCarloPanel.SaveChanges(); }
            this._session.SaveRequired = true;
        }
        void Close_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }
        #endregion
        #region 
        #region 
        MonteCarloPanel ux_monteCarloPanel;
        RichTextBox     ux_statusTextBox;
        Button          ux_close;
        Button          ux_save;
        #endregion
        static readonly Size PreferredMCPanelSize = new Size(474, 389);
        Session _session;
        bool _isMC;         
        #endregion
    }
}

