#region << Using Directives >>
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Volpe.Cafe.Data;
using Volpe.Cafe.Model;
using Volpe.Cafe.Optimization.Model;
using Volpe.Cafe.Optimization.Settings;
using Volpe.Cafe.Settings;
using Volpe.Cafe.UI.Panels;
#endregion
namespace Volpe.Cafe.UI
{
    public class ManageOptimization : Form
    {
        #region 
        public ManageOptimization(Session session)
        {
            this.InitializeComponent();
            this._session = session;
            this._isOPT = (this._session.Compliance is OptimizationModel);
            Industry data = session.Data;
            if (data == null)
            {
                this._minYear = DateTime.Now.Year - 5;
                this._maxYear = this._minYear + 50;
            }
            else
            {
                this._minYear = data.MinYear.Year;
                this._maxYear = data.MaxYear.Year;
            }
        }
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }
        #endregion
        #region 
        #region 
        void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ManageOptimization));
            this.ux_statusTextBox = new System.Windows.Forms.RichTextBox();
            this.ux_close = new System.Windows.Forms.Button();
            this.ux_save = new System.Windows.Forms.Button();
            this.ux_optimizationPanel = new Volpe.Cafe.UI.Panels.OptimizationPanel();
            this.SuspendLayout();
            this.ux_statusTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_statusTextBox.BackColor = System.Drawing.SystemColors.Control;
            this.ux_statusTextBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.ux_statusTextBox.Enabled = false;
            this.ux_statusTextBox.ForeColor = System.Drawing.Color.Black;
            this.ux_statusTextBox.Location = new System.Drawing.Point(8, 389);
            this.ux_statusTextBox.Name = "ux_statusTextBox";
            this.ux_statusTextBox.ReadOnly = true;
            this.ux_statusTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Vertical;
            this.ux_statusTextBox.Size = new System.Drawing.Size(344, 56);
            this.ux_statusTextBox.TabIndex = 1;
            this.ux_statusTextBox.TabStop = false;
            this.ux_statusTextBox.Text = "";
            this.ux_close.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_close.BackColor = System.Drawing.SystemColors.Control;
            this.ux_close.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.ux_close.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_close.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_close.ForeColor = System.Drawing.Color.Red;
            this.ux_close.Location = new System.Drawing.Point(416, 389);
            this.ux_close.Name = "ux_close";
            this.ux_close.Size = new System.Drawing.Size(48, 48);
            this.ux_close.TabIndex = 3;
            this.ux_close.Text = "Close";
            this.ux_close.UseVisualStyleBackColor = false;
            this.ux_close.Click += new System.EventHandler(this.Close_Click);
            this.ux_save.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_save.BackColor = System.Drawing.SystemColors.Control;
            this.ux_save.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_save.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_save.ForeColor = System.Drawing.Color.Green;
            this.ux_save.Location = new System.Drawing.Point(360, 389);
            this.ux_save.Name = "ux_save";
            this.ux_save.Size = new System.Drawing.Size(48, 48);
            this.ux_save.TabIndex = 2;
            this.ux_save.Text = "Save";
            this.ux_save.UseVisualStyleBackColor = false;
            this.ux_save.Click += new System.EventHandler(this.Save_Click);
            this.ux_optimizationPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_optimizationPanel.AutoScroll = true;
            this.ux_optimizationPanel.Location = new System.Drawing.Point(8, 8);
            this.ux_optimizationPanel.MinimumSize = new System.Drawing.Size(440, 0);
            this.ux_optimizationPanel.Name = "ux_optimizationPanel";
            this.ux_optimizationPanel.Size = new System.Drawing.Size(440, 176);
            this.ux_optimizationPanel.TabIndex = 0;
            this.ux_optimizationPanel.Visible = false;
            this.AcceptButton = this.ux_save;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.ux_close;
            this.ClientSize = new System.Drawing.Size(474, 452);
            this.Controls.Add(this.ux_close);
            this.Controls.Add(this.ux_save);
            this.Controls.Add(this.ux_optimizationPanel);
            this.Controls.Add(this.ux_statusTextBox);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.MinimumSize = new System.Drawing.Size(480, 480);
            this.Name = "ManageOptimization";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Manage Optimization";
            this.ResumeLayout(false);
        }
        #endregion
        #region 
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (this._isOPT)
            {   
                this.ux_optimizationPanel.Messages.MessagesChanged += new EventHandler(this.Messages_MessagesChanged);
                this.ux_optimizationPanel.SetInitialState(
                    (OptimizationSettings)this._session.Settings.GetRuntimeSettings(typeof(OptimizationSettings)), this._minYear, this._maxYear);
                this.ux_optimizationPanel.Location = new Point(0, 0);
                this.ux_optimizationPanel.Size = PreferredOptPanelSize;
                this.ux_optimizationPanel.Visible = true;
            }
            else
            {   
                Label warningLabel = new Label();
                warningLabel.Location = new Point(0, 0);
                warningLabel.Size = PreferredOptPanelSize;
                warningLabel.Font = new Font(this.Font.FontFamily, 14);
                warningLabel.ForeColor = Color.Red;
                warningLabel.TextAlign = ContentAlignment.MiddleCenter;
                warningLabel.Text = "No valid optimization model selected.";
                this.Controls.Add(warningLabel);
            }
            Application.Idle += new EventHandler(this.ManageOptimization_Idle);
            this.ux_save.Visible = !this._session.Running;
        }
        protected override void OnClosing(CancelEventArgs e)
        {
            if (this._isOPT) { this.ux_optimizationPanel.Messages.MessagesChanged -= new EventHandler(this.Messages_MessagesChanged); }
            Application.Idle -= new EventHandler(this.ManageOptimization_Idle);
            base.OnClosing(e);
        }
        #endregion
        void ManageOptimization_Idle(object sender, EventArgs e)
        {
            this.ux_save.Enabled = !this._session.Running && this._isOPT && this.ux_optimizationPanel.SettingsChanged;
        }
        void Messages_MessagesChanged(object sender, EventArgs e)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new EventHandler(this.Messages_MessagesChanged));
            }
            else
            {
                string messages = (this._isOPT) ? this.ux_optimizationPanel  .Messages.ToString() : string.Empty;
                this.ux_statusTextBox.Text      = messages;
                this.ux_statusTextBox.ForeColor = Color.Red;
                this.ux_statusTextBox.Enabled   = this.ux_statusTextBox.Text != string.Empty;
            }
        }
        void Save_Click(object sender, System.EventArgs e)
        {
            if (this._isOPT) { this.ux_optimizationPanel.SaveChanges(); }
            this._session.SaveRequired = true;
        }
        void Close_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }
        #endregion
        #region 
        #region 
        OptimizationPanel ux_optimizationPanel;
        RichTextBox ux_statusTextBox;
        Button ux_close;
        Button ux_save;
        #endregion
        static readonly Size PreferredOptPanelSize = new Size(474, 389);
        Session _session;
        bool _isOPT;        
        int _minYear;
        int _maxYear;
        #endregion
    }
}

