using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Threading;
using System.Windows.Forms;
using Volpe.Cafe.Data;
using Volpe.Cafe.EIS.Settings;
using Volpe.Cafe.EIS.IO;
using Volpe.Cafe.EIS.IO.InputParsers;
using Volpe.Cafe.IO;
using Volpe.Cafe.IO.InputParsers;
using Volpe.Cafe.Settings;
using Volpe.Cafe.Utils;
namespace Volpe.Cafe.UI.Panels
{
	public class InputPanel : CafeUserControl
	{
        #region 
        public event EventHandler ParsingChanged;
        #endregion
        #region 
		public InputPanel()
		{
			this.InitializeComponent();
            this.PostInitialize();
        }
		protected override void Dispose(bool disposing)
		{
			base.Dispose(disposing);
		}
        #endregion
        #region 
		#region 
		void InitializeComponent()
		{
            this.ux_encryptionLabel = new System.Windows.Forms.Label();
            this.ux_encryptionPanel = new System.Windows.Forms.Panel();
            this.ux_inputPasswordLabel3 = new System.Windows.Forms.Label();
            this.ux_inputPasswordLabel2 = new System.Windows.Forms.Label();
            this.ux_inputPasswordVerfiy = new System.Windows.Forms.TextBox();
            this.ux_inputPasswordLabel1 = new System.Windows.Forms.Label();
            this.ux_inputPassword = new System.Windows.Forms.TextBox();
            this.ux_encryptInput = new System.Windows.Forms.RadioButton();
            this.ux_doNotEncryptInput = new System.Windows.Forms.RadioButton();
            this.ux_inputFilesLabel = new System.Windows.Forms.Label();
            this.ux_inputFilesPanel = new System.Windows.Forms.Panel();
            this.ux_eisTailpipeEmissionsFileBrowse = new System.Windows.Forms.Button();
            this.ux_eisTailpipeEmissionsFile = new System.Windows.Forms.TextBox();
            this.ux_eisTailpipeEmissionsFileOutdatedLabel = new System.Windows.Forms.Label();
            this.ux_eisTailpipeEmissionsFileLabel = new System.Windows.Forms.Label();
            this.ux_eisParametersFileBrowse = new System.Windows.Forms.Button();
            this.ux_eisParametersFile = new System.Windows.Forms.TextBox();
            this.ux_eisParametersFileOutdatedLabel = new System.Windows.Forms.Label();
            this.ux_eisParametersFileLabel = new System.Windows.Forms.Label();
            this.ux_reloadAllFromDisk = new System.Windows.Forms.CheckBox();
            this.ux_scenariosFileBrowse = new System.Windows.Forms.Button();
            this.ux_scenariosFile = new System.Windows.Forms.TextBox();
            this.ux_tailpipeEmissionsFileBrowse = new System.Windows.Forms.Button();
            this.ux_tailpipeEmissionsFile = new System.Windows.Forms.TextBox();
            this.ux_parametersFileBrowse = new System.Windows.Forms.Button();
            this.ux_parametersFile = new System.Windows.Forms.TextBox();
            this.ux_technologiesFileBrowse = new System.Windows.Forms.Button();
            this.ux_technologiesFile = new System.Windows.Forms.TextBox();
            this.ux_marketDataFileBrowse = new System.Windows.Forms.Button();
            this.ux_marketDataFile = new System.Windows.Forms.TextBox();
            this.ux_marketDataFileOutdatedLabel = new System.Windows.Forms.Label();
            this.ux_scenariosFileOutdatedLabel = new System.Windows.Forms.Label();
            this.ux_tailpipeEmissionsFileOutdatedLabel = new System.Windows.Forms.Label();
            this.ux_parametersFileOutdatedLabel = new System.Windows.Forms.Label();
            this.ux_technologiesFileOutdatedLabel = new System.Windows.Forms.Label();
            this.ux_technologiesFileLabel = new System.Windows.Forms.Label();
            this.ux_parametersFileLabel = new System.Windows.Forms.Label();
            this.ux_tailpipeEmissionsFileLabel = new System.Windows.Forms.Label();
            this.ux_scenariosFileLabel = new System.Windows.Forms.Label();
            this.ux_marketDataFileLabel = new System.Windows.Forms.Label();
            this.ux_encryptionPanel.SuspendLayout();
            this.ux_inputFilesPanel.SuspendLayout();
            this.SuspendLayout();
            this.ux_encryptionLabel.AutoSize = true;
            this.ux_encryptionLabel.Location = new System.Drawing.Point(8, 8);
            this.ux_encryptionLabel.Name = "ux_encryptionLabel";
            this.ux_encryptionLabel.Size = new System.Drawing.Size(222, 13);
            this.ux_encryptionLabel.TabIndex = 0;
            this.ux_encryptionLabel.Text = "Are any of the input files password protected?";
            this.ux_encryptionPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_encryptionPanel.Controls.Add(this.ux_inputPasswordLabel3);
            this.ux_encryptionPanel.Controls.Add(this.ux_inputPasswordLabel2);
            this.ux_encryptionPanel.Controls.Add(this.ux_inputPasswordVerfiy);
            this.ux_encryptionPanel.Controls.Add(this.ux_inputPasswordLabel1);
            this.ux_encryptionPanel.Controls.Add(this.ux_inputPassword);
            this.ux_encryptionPanel.Controls.Add(this.ux_encryptInput);
            this.ux_encryptionPanel.Controls.Add(this.ux_doNotEncryptInput);
            this.ux_encryptionPanel.Location = new System.Drawing.Point(8, 16);
            this.ux_encryptionPanel.Name = "ux_encryptionPanel";
            this.ux_encryptionPanel.Size = new System.Drawing.Size(424, 80);
            this.ux_encryptionPanel.TabIndex = 1;
            this.ux_inputPasswordLabel3.AutoSize = true;
            this.ux_inputPasswordLabel3.Enabled = false;
            this.ux_inputPasswordLabel3.ForeColor = System.Drawing.Color.DarkRed;
            this.ux_inputPasswordLabel3.Location = new System.Drawing.Point(24, 64);
            this.ux_inputPasswordLabel3.Name = "ux_inputPasswordLabel3";
            this.ux_inputPasswordLabel3.Size = new System.Drawing.Size(311, 13);
            this.ux_inputPasswordLabel3.TabIndex = 7;
            this.ux_inputPasswordLabel3.Text = "Note:  The same password will be used for opening all input files.";
            this.ux_inputPasswordLabel2.Enabled = false;
            this.ux_inputPasswordLabel2.Location = new System.Drawing.Point(360, 44);
            this.ux_inputPasswordLabel2.Name = "ux_inputPasswordLabel2";
            this.ux_inputPasswordLabel2.Size = new System.Drawing.Size(8, 16);
            this.ux_inputPasswordLabel2.TabIndex = 5;
            this.ux_inputPasswordLabel2.Text = ")";
            this.ux_inputPasswordVerfiy.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_inputPasswordVerfiy.Enabled = false;
            this.ux_inputPasswordVerfiy.Location = new System.Drawing.Point(238, 40);
            this.ux_inputPasswordVerfiy.Name = "ux_inputPasswordVerfiy";
            this.ux_inputPasswordVerfiy.PasswordChar = '*';
            this.ux_inputPasswordVerfiy.Size = new System.Drawing.Size(120, 20);
            this.ux_inputPasswordVerfiy.TabIndex = 4;
            this.ux_inputPasswordLabel1.AutoSize = true;
            this.ux_inputPasswordLabel1.Enabled = false;
            this.ux_inputPasswordLabel1.Location = new System.Drawing.Point(148, 44);
            this.ux_inputPasswordLabel1.Name = "ux_inputPasswordLabel1";
            this.ux_inputPasswordLabel1.Size = new System.Drawing.Size(86, 13);
            this.ux_inputPasswordLabel1.TabIndex = 3;
            this.ux_inputPasswordLabel1.Text = "(verify password:";
            this.ux_inputPassword.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_inputPassword.Enabled = false;
            this.ux_inputPassword.Location = new System.Drawing.Point(24, 40);
            this.ux_inputPassword.Name = "ux_inputPassword";
            this.ux_inputPassword.PasswordChar = '*';
            this.ux_inputPassword.Size = new System.Drawing.Size(120, 20);
            this.ux_inputPassword.TabIndex = 2;
            this.ux_encryptInput.AutoSize = true;
            this.ux_encryptInput.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_encryptInput.Location = new System.Drawing.Point(8, 24);
            this.ux_encryptInput.Name = "ux_encryptInput";
            this.ux_encryptInput.Size = new System.Drawing.Size(298, 17);
            this.ux_encryptInput.TabIndex = 1;
            this.ux_encryptInput.Text = "The input files are protected using the specified password:";
            this.ux_doNotEncryptInput.AutoSize = true;
            this.ux_doNotEncryptInput.Checked = true;
            this.ux_doNotEncryptInput.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_doNotEncryptInput.Location = new System.Drawing.Point(8, 8);
            this.ux_doNotEncryptInput.Name = "ux_doNotEncryptInput";
            this.ux_doNotEncryptInput.Size = new System.Drawing.Size(257, 17);
            this.ux_doNotEncryptInput.TabIndex = 0;
            this.ux_doNotEncryptInput.TabStop = true;
            this.ux_doNotEncryptInput.Text = "The input files do not require a password to open,";
            this.ux_inputFilesLabel.AutoSize = true;
            this.ux_inputFilesLabel.Location = new System.Drawing.Point(8, 100);
            this.ux_inputFilesLabel.Name = "ux_inputFilesLabel";
            this.ux_inputFilesLabel.Size = new System.Drawing.Size(316, 13);
            this.ux_inputFilesLabel.TabIndex = 2;
            this.ux_inputFilesLabel.Text = "Please specify the input files you would like to use with the model:";
            this.ux_inputFilesPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisTailpipeEmissionsFileBrowse);
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisTailpipeEmissionsFile);
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisTailpipeEmissionsFileOutdatedLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisTailpipeEmissionsFileLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisParametersFileBrowse);
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisParametersFile);
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisParametersFileOutdatedLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_eisParametersFileLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_reloadAllFromDisk);
            this.ux_inputFilesPanel.Controls.Add(this.ux_scenariosFileBrowse);
            this.ux_inputFilesPanel.Controls.Add(this.ux_scenariosFile);
            this.ux_inputFilesPanel.Controls.Add(this.ux_tailpipeEmissionsFileBrowse);
            this.ux_inputFilesPanel.Controls.Add(this.ux_tailpipeEmissionsFile);
            this.ux_inputFilesPanel.Controls.Add(this.ux_parametersFileBrowse);
            this.ux_inputFilesPanel.Controls.Add(this.ux_parametersFile);
            this.ux_inputFilesPanel.Controls.Add(this.ux_technologiesFileBrowse);
            this.ux_inputFilesPanel.Controls.Add(this.ux_technologiesFile);
            this.ux_inputFilesPanel.Controls.Add(this.ux_marketDataFileBrowse);
            this.ux_inputFilesPanel.Controls.Add(this.ux_marketDataFile);
            this.ux_inputFilesPanel.Controls.Add(this.ux_marketDataFileOutdatedLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_scenariosFileOutdatedLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_tailpipeEmissionsFileOutdatedLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_parametersFileOutdatedLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_technologiesFileOutdatedLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_technologiesFileLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_parametersFileLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_tailpipeEmissionsFileLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_scenariosFileLabel);
            this.ux_inputFilesPanel.Controls.Add(this.ux_marketDataFileLabel);
            this.ux_inputFilesPanel.Location = new System.Drawing.Point(8, 108);
            this.ux_inputFilesPanel.Name = "ux_inputFilesPanel";
            this.ux_inputFilesPanel.Size = new System.Drawing.Size(424, 308);
            this.ux_inputFilesPanel.TabIndex = 3;
            this.ux_eisTailpipeEmissionsFileBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_eisTailpipeEmissionsFileBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_eisTailpipeEmissionsFileBrowse.Location = new System.Drawing.Point(344, 264);
            this.ux_eisTailpipeEmissionsFileBrowse.Name = "ux_eisTailpipeEmissionsFileBrowse";
            this.ux_eisTailpipeEmissionsFileBrowse.Size = new System.Drawing.Size(80, 21);
            this.ux_eisTailpipeEmissionsFileBrowse.TabIndex = 27;
            this.ux_eisTailpipeEmissionsFileBrowse.Text = "Browse";
            this.ux_eisTailpipeEmissionsFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_eisTailpipeEmissionsFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_eisTailpipeEmissionsFile.Location = new System.Drawing.Point(8, 264);
            this.ux_eisTailpipeEmissionsFile.Name = "ux_eisTailpipeEmissionsFile";
            this.ux_eisTailpipeEmissionsFile.Size = new System.Drawing.Size(335, 20);
            this.ux_eisTailpipeEmissionsFile.TabIndex = 26;
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.AutoEllipsis = true;
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.AutoSize = true;
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.ForeColor = System.Drawing.Color.Gray;
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.Location = new System.Drawing.Point(140, 248);
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.Name = "ux_eisTailpipeEmissionsFileOutdatedLabel";
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.Size = new System.Drawing.Size(228, 13);
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.TabIndex = 25;
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.Text = "(The file on disk is newer than data in memory.)";
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.Visible = false;
            this.ux_eisTailpipeEmissionsFileLabel.AutoSize = true;
            this.ux_eisTailpipeEmissionsFileLabel.Location = new System.Drawing.Point(8, 248);
            this.ux_eisTailpipeEmissionsFileLabel.Name = "ux_eisTailpipeEmissionsFileLabel";
            this.ux_eisTailpipeEmissionsFileLabel.Size = new System.Drawing.Size(132, 13);
            this.ux_eisTailpipeEmissionsFileLabel.TabIndex = 24;
            this.ux_eisTailpipeEmissionsFileLabel.Text = "EIS Tailpipe Emissions file:";
            this.ux_eisParametersFileBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_eisParametersFileBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_eisParametersFileBrowse.Location = new System.Drawing.Point(344, 224);
            this.ux_eisParametersFileBrowse.Name = "ux_eisParametersFileBrowse";
            this.ux_eisParametersFileBrowse.Size = new System.Drawing.Size(80, 21);
            this.ux_eisParametersFileBrowse.TabIndex = 23;
            this.ux_eisParametersFileBrowse.Text = "Browse";
            this.ux_eisParametersFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_eisParametersFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_eisParametersFile.Location = new System.Drawing.Point(8, 224);
            this.ux_eisParametersFile.Name = "ux_eisParametersFile";
            this.ux_eisParametersFile.Size = new System.Drawing.Size(335, 20);
            this.ux_eisParametersFile.TabIndex = 22;
            this.ux_eisParametersFileOutdatedLabel.AutoEllipsis = true;
            this.ux_eisParametersFileOutdatedLabel.AutoSize = true;
            this.ux_eisParametersFileOutdatedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_eisParametersFileOutdatedLabel.ForeColor = System.Drawing.Color.Gray;
            this.ux_eisParametersFileOutdatedLabel.Location = new System.Drawing.Point(110, 208);
            this.ux_eisParametersFileOutdatedLabel.Name = "ux_eisParametersFileOutdatedLabel";
            this.ux_eisParametersFileOutdatedLabel.Size = new System.Drawing.Size(228, 13);
            this.ux_eisParametersFileOutdatedLabel.TabIndex = 21;
            this.ux_eisParametersFileOutdatedLabel.Text = "(The file on disk is newer than data in memory.)";
            this.ux_eisParametersFileOutdatedLabel.Visible = false;
            this.ux_eisParametersFileLabel.AutoSize = true;
            this.ux_eisParametersFileLabel.Location = new System.Drawing.Point(8, 208);
            this.ux_eisParametersFileLabel.Name = "ux_eisParametersFileLabel";
            this.ux_eisParametersFileLabel.Size = new System.Drawing.Size(99, 13);
            this.ux_eisParametersFileLabel.TabIndex = 20;
            this.ux_eisParametersFileLabel.Text = "EIS Parameters file:";
            this.ux_reloadAllFromDisk.AutoSize = true;
            this.ux_reloadAllFromDisk.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_reloadAllFromDisk.Location = new System.Drawing.Point(8, 288);
            this.ux_reloadAllFromDisk.Name = "ux_reloadAllFromDisk";
            this.ux_reloadAllFromDisk.Size = new System.Drawing.Size(183, 17);
            this.ux_reloadAllFromDisk.TabIndex = 99;
            this.ux_reloadAllFromDisk.Text = "Reload all selected files from disk.";
            this.ux_scenariosFileBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_scenariosFileBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_scenariosFileBrowse.Location = new System.Drawing.Point(344, 184);
            this.ux_scenariosFileBrowse.Name = "ux_scenariosFileBrowse";
            this.ux_scenariosFileBrowse.Size = new System.Drawing.Size(80, 21);
            this.ux_scenariosFileBrowse.TabIndex = 19;
            this.ux_scenariosFileBrowse.Text = "Browse";
            this.ux_scenariosFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_scenariosFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_scenariosFile.Location = new System.Drawing.Point(8, 184);
            this.ux_scenariosFile.Name = "ux_scenariosFile";
            this.ux_scenariosFile.Size = new System.Drawing.Size(335, 20);
            this.ux_scenariosFile.TabIndex = 18;
            this.ux_tailpipeEmissionsFileBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_tailpipeEmissionsFileBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_tailpipeEmissionsFileBrowse.Location = new System.Drawing.Point(344, 144);
            this.ux_tailpipeEmissionsFileBrowse.Name = "ux_tailpipeEmissionsFileBrowse";
            this.ux_tailpipeEmissionsFileBrowse.Size = new System.Drawing.Size(80, 21);
            this.ux_tailpipeEmissionsFileBrowse.TabIndex = 15;
            this.ux_tailpipeEmissionsFileBrowse.Text = "Browse";
            this.ux_tailpipeEmissionsFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_tailpipeEmissionsFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_tailpipeEmissionsFile.Location = new System.Drawing.Point(8, 144);
            this.ux_tailpipeEmissionsFile.Name = "ux_tailpipeEmissionsFile";
            this.ux_tailpipeEmissionsFile.Size = new System.Drawing.Size(335, 20);
            this.ux_tailpipeEmissionsFile.TabIndex = 14;
            this.ux_parametersFileBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_parametersFileBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_parametersFileBrowse.Location = new System.Drawing.Point(344, 104);
            this.ux_parametersFileBrowse.Name = "ux_parametersFileBrowse";
            this.ux_parametersFileBrowse.Size = new System.Drawing.Size(80, 21);
            this.ux_parametersFileBrowse.TabIndex = 11;
            this.ux_parametersFileBrowse.Text = "Browse";
            this.ux_parametersFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_parametersFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_parametersFile.Location = new System.Drawing.Point(8, 104);
            this.ux_parametersFile.Name = "ux_parametersFile";
            this.ux_parametersFile.Size = new System.Drawing.Size(335, 20);
            this.ux_parametersFile.TabIndex = 10;
            this.ux_technologiesFileBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_technologiesFileBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_technologiesFileBrowse.Location = new System.Drawing.Point(344, 64);
            this.ux_technologiesFileBrowse.Name = "ux_technologiesFileBrowse";
            this.ux_technologiesFileBrowse.Size = new System.Drawing.Size(80, 21);
            this.ux_technologiesFileBrowse.TabIndex = 7;
            this.ux_technologiesFileBrowse.Text = "Browse";
            this.ux_technologiesFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_technologiesFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_technologiesFile.Location = new System.Drawing.Point(8, 64);
            this.ux_technologiesFile.Name = "ux_technologiesFile";
            this.ux_technologiesFile.Size = new System.Drawing.Size(335, 20);
            this.ux_technologiesFile.TabIndex = 6;
            this.ux_marketDataFileBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_marketDataFileBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_marketDataFileBrowse.Location = new System.Drawing.Point(344, 24);
            this.ux_marketDataFileBrowse.Name = "ux_marketDataFileBrowse";
            this.ux_marketDataFileBrowse.Size = new System.Drawing.Size(80, 21);
            this.ux_marketDataFileBrowse.TabIndex = 3;
            this.ux_marketDataFileBrowse.Text = "Browse";
            this.ux_marketDataFile.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_marketDataFile.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_marketDataFile.Location = new System.Drawing.Point(8, 24);
            this.ux_marketDataFile.Name = "ux_marketDataFile";
            this.ux_marketDataFile.Size = new System.Drawing.Size(335, 20);
            this.ux_marketDataFile.TabIndex = 2;
            this.ux_marketDataFileOutdatedLabel.AutoEllipsis = true;
            this.ux_marketDataFileOutdatedLabel.AutoSize = true;
            this.ux_marketDataFileOutdatedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_marketDataFileOutdatedLabel.ForeColor = System.Drawing.Color.Gray;
            this.ux_marketDataFileOutdatedLabel.Location = new System.Drawing.Point(96, 8);
            this.ux_marketDataFileOutdatedLabel.Name = "ux_marketDataFileOutdatedLabel";
            this.ux_marketDataFileOutdatedLabel.Size = new System.Drawing.Size(228, 13);
            this.ux_marketDataFileOutdatedLabel.TabIndex = 1;
            this.ux_marketDataFileOutdatedLabel.Text = "(The file on disk is newer than data in memory.)";
            this.ux_marketDataFileOutdatedLabel.Visible = false;
            this.ux_scenariosFileOutdatedLabel.AutoEllipsis = true;
            this.ux_scenariosFileOutdatedLabel.AutoSize = true;
            this.ux_scenariosFileOutdatedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_scenariosFileOutdatedLabel.ForeColor = System.Drawing.Color.Gray;
            this.ux_scenariosFileOutdatedLabel.Location = new System.Drawing.Point(80, 168);
            this.ux_scenariosFileOutdatedLabel.Name = "ux_scenariosFileOutdatedLabel";
            this.ux_scenariosFileOutdatedLabel.Size = new System.Drawing.Size(228, 13);
            this.ux_scenariosFileOutdatedLabel.TabIndex = 17;
            this.ux_scenariosFileOutdatedLabel.Text = "(The file on disk is newer than data in memory.)";
            this.ux_scenariosFileOutdatedLabel.Visible = false;
            this.ux_tailpipeEmissionsFileOutdatedLabel.AutoEllipsis = true;
            this.ux_tailpipeEmissionsFileOutdatedLabel.AutoSize = true;
            this.ux_tailpipeEmissionsFileOutdatedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_tailpipeEmissionsFileOutdatedLabel.ForeColor = System.Drawing.Color.Gray;
            this.ux_tailpipeEmissionsFileOutdatedLabel.Location = new System.Drawing.Point(120, 128);
            this.ux_tailpipeEmissionsFileOutdatedLabel.Name = "ux_tailpipeEmissionsFileOutdatedLabel";
            this.ux_tailpipeEmissionsFileOutdatedLabel.Size = new System.Drawing.Size(228, 13);
            this.ux_tailpipeEmissionsFileOutdatedLabel.TabIndex = 13;
            this.ux_tailpipeEmissionsFileOutdatedLabel.Text = "(The file on disk is newer than data in memory.)";
            this.ux_tailpipeEmissionsFileOutdatedLabel.Visible = false;
            this.ux_parametersFileOutdatedLabel.AutoEllipsis = true;
            this.ux_parametersFileOutdatedLabel.AutoSize = true;
            this.ux_parametersFileOutdatedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_parametersFileOutdatedLabel.ForeColor = System.Drawing.Color.Gray;
            this.ux_parametersFileOutdatedLabel.Location = new System.Drawing.Point(88, 88);
            this.ux_parametersFileOutdatedLabel.Name = "ux_parametersFileOutdatedLabel";
            this.ux_parametersFileOutdatedLabel.Size = new System.Drawing.Size(228, 13);
            this.ux_parametersFileOutdatedLabel.TabIndex = 9;
            this.ux_parametersFileOutdatedLabel.Text = "(The file on disk is newer than data in memory.)";
            this.ux_parametersFileOutdatedLabel.Visible = false;
            this.ux_technologiesFileOutdatedLabel.AutoEllipsis = true;
            this.ux_technologiesFileOutdatedLabel.AutoSize = true;
            this.ux_technologiesFileOutdatedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_technologiesFileOutdatedLabel.ForeColor = System.Drawing.Color.Gray;
            this.ux_technologiesFileOutdatedLabel.Location = new System.Drawing.Point(96, 48);
            this.ux_technologiesFileOutdatedLabel.Name = "ux_technologiesFileOutdatedLabel";
            this.ux_technologiesFileOutdatedLabel.Size = new System.Drawing.Size(228, 13);
            this.ux_technologiesFileOutdatedLabel.TabIndex = 5;
            this.ux_technologiesFileOutdatedLabel.Text = "(The file on disk is newer than data in memory.)";
            this.ux_technologiesFileOutdatedLabel.Visible = false;
            this.ux_technologiesFileLabel.AutoSize = true;
            this.ux_technologiesFileLabel.Location = new System.Drawing.Point(8, 48);
            this.ux_technologiesFileLabel.Name = "ux_technologiesFileLabel";
            this.ux_technologiesFileLabel.Size = new System.Drawing.Size(90, 13);
            this.ux_technologiesFileLabel.TabIndex = 4;
            this.ux_technologiesFileLabel.Text = "Technologies file:";
            this.ux_parametersFileLabel.AutoSize = true;
            this.ux_parametersFileLabel.Location = new System.Drawing.Point(8, 88);
            this.ux_parametersFileLabel.Name = "ux_parametersFileLabel";
            this.ux_parametersFileLabel.Size = new System.Drawing.Size(79, 13);
            this.ux_parametersFileLabel.TabIndex = 8;
            this.ux_parametersFileLabel.Text = "Parameters file:";
            this.ux_tailpipeEmissionsFileLabel.AutoSize = true;
            this.ux_tailpipeEmissionsFileLabel.Location = new System.Drawing.Point(8, 128);
            this.ux_tailpipeEmissionsFileLabel.Name = "ux_tailpipeEmissionsFileLabel";
            this.ux_tailpipeEmissionsFileLabel.Size = new System.Drawing.Size(112, 13);
            this.ux_tailpipeEmissionsFileLabel.TabIndex = 12;
            this.ux_tailpipeEmissionsFileLabel.Text = "Tailpipe Emissions file:";
            this.ux_scenariosFileLabel.AutoSize = true;
            this.ux_scenariosFileLabel.Location = new System.Drawing.Point(8, 168);
            this.ux_scenariosFileLabel.Name = "ux_scenariosFileLabel";
            this.ux_scenariosFileLabel.Size = new System.Drawing.Size(73, 13);
            this.ux_scenariosFileLabel.TabIndex = 16;
            this.ux_scenariosFileLabel.Text = "Scenarios file:";
            this.ux_marketDataFileLabel.AutoSize = true;
            this.ux_marketDataFileLabel.Location = new System.Drawing.Point(8, 8);
            this.ux_marketDataFileLabel.Name = "ux_marketDataFileLabel";
            this.ux_marketDataFileLabel.Size = new System.Drawing.Size(85, 13);
            this.ux_marketDataFileLabel.TabIndex = 0;
            this.ux_marketDataFileLabel.Text = "Market-Data file:";
            this.Controls.Add(this.ux_inputFilesLabel);
            this.Controls.Add(this.ux_encryptionLabel);
            this.Controls.Add(this.ux_encryptionPanel);
            this.Controls.Add(this.ux_inputFilesPanel);
            this.MinimumSize = new System.Drawing.Size(440, 0);
            this.Name = "InputPanel";
            this.Size = new System.Drawing.Size(440, 424);
            this.ux_encryptionPanel.ResumeLayout(false);
            this.ux_encryptionPanel.PerformLayout();
            this.ux_inputFilesPanel.ResumeLayout(false);
            this.ux_inputFilesPanel.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();
        }
		#endregion
        #region 
        protected virtual void OnParsingChanged(EventArgs e)
        {
            if (this.ParsingChanged != null)
            {
                this.ParsingChanged(this, e);
            }
        }
        #endregion
        void PostInitialize()
        {
            this.InitializeInputPanelDragDrop();
            this.AutoInitializeCheckChangesDetector(this.Controls);
            this.DeInitializeCheckChangesDetector(this.ux_reloadAllFromDisk);
            this.ux_encryptInput                  .CheckedChanged += new EventHandler(this.EncryptInput_CheckedChanged);
            this.ux_inputPassword                 .TextChanged    += new EventHandler(this.InputPassword_TextChanged);
            this.ux_inputPasswordVerfiy           .TextChanged    += new EventHandler(this.InputPassword_TextChanged);
            this.ux_inputPassword                 .EnabledChanged += new EventHandler(this.InputPassword_EnabledChanged);
            this.ux_inputPasswordVerfiy           .EnabledChanged += new EventHandler(this.InputPassword_EnabledChanged);
            this.ux_marketDataFile                .TextChanged    += new EventHandler(this.InputFile_TextChanged);
            this.ux_technologiesFile              .TextChanged    += new EventHandler(this.InputFile_TextChanged);
            this.ux_parametersFile                .TextChanged    += new EventHandler(this.InputFile_TextChanged);
            this.ux_tailpipeEmissionsFile         .TextChanged    += new EventHandler(this.InputFile_TextChanged);
            this.ux_scenariosFile                 .TextChanged    += new EventHandler(this.InputFile_TextChanged);
            this.ux_eisParametersFile             .TextChanged    += new EventHandler(this.InputFile_TextChanged);
            this.ux_eisTailpipeEmissionsFile      .TextChanged    += new EventHandler(this.InputFile_TextChanged);
            this.ux_marketDataFile                .VisibleChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_technologiesFile              .VisibleChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_parametersFile                .VisibleChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_tailpipeEmissionsFile         .VisibleChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_scenariosFile                 .VisibleChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_eisParametersFile             .VisibleChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_eisTailpipeEmissionsFile      .VisibleChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_marketDataFile                .EnabledChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_technologiesFile              .EnabledChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_parametersFile                .EnabledChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_tailpipeEmissionsFile         .EnabledChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_scenariosFile                 .EnabledChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_eisParametersFile             .EnabledChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_eisTailpipeEmissionsFile      .EnabledChanged += new EventHandler(this.InputFile_VisibleOrEnabledChanged);
            this.ux_marketDataFileBrowse          .Click          += new EventHandler(this.InputFileBrowse_Click);
            this.ux_technologiesFileBrowse        .Click          += new EventHandler(this.InputFileBrowse_Click);
            this.ux_parametersFileBrowse          .Click          += new EventHandler(this.InputFileBrowse_Click);
            this.ux_tailpipeEmissionsFileBrowse   .Click          += new EventHandler(this.InputFileBrowse_Click);
            this.ux_scenariosFileBrowse           .Click          += new EventHandler(this.InputFileBrowse_Click);
            this.ux_eisParametersFileBrowse       .Click          += new EventHandler(this.InputFileBrowse_Click);
            this.ux_eisTailpipeEmissionsFileBrowse.Click          += new EventHandler(this.InputFileBrowse_Click);
            this.ux_marketDataFile          .Text = " ";
            this.ux_technologiesFile        .Text = " ";
            this.ux_parametersFile          .Text = " ";
            this.ux_tailpipeEmissionsFile   .Text = " ";
            this.ux_scenariosFile           .Text = " ";
            this.ux_eisParametersFile       .Text = " ";
            this.ux_eisTailpipeEmissionsFile.Text = " ";
            this._data          = new object[FileCount];
            this._verifiedFiles = new bool  [FileCount];
            this._visibleFiles  = new bool  [FileCount];
            this._loadFailed    = new bool  [FileCount];
            for (int i = 0; i < FileCount; i++) { this._visibleFiles[i] = true; }
            this._parsing = 0;
            this._saveThread = null;
        }
        void EncryptInput_CheckedChanged(object sender, EventArgs e)
        {
            bool enabled = this.ux_encryptInput.Checked;
            this.ux_inputPassword      .Enabled = enabled;
            this.ux_inputPasswordVerfiy.Enabled = enabled;
            this.ux_inputPasswordLabel1.Enabled = enabled;
            this.ux_inputPasswordLabel2.Enabled = enabled;
            this.ux_inputPasswordLabel3.Enabled = enabled;
        }
        void InputPassword_TextChanged(object sender, EventArgs e)
        {
            string pw1 = this.ux_inputPassword.Text;
            string pw2 = this.ux_inputPasswordVerfiy.Text;
            string errMessage = string.Empty;
            if (pw1 == "" && pw2 == "")
            {
                errMessage = "Please enter an input password and verify.";
            }
            else if (pw1 == pw2)
            {
                bool  pwChanged = pw1 != this._inputSettings.InputPassword;
                Color foreColor = (pwChanged && this._visualTracking) ? this._visualTrackingColor : Control.DefaultForeColor;
                this.ux_inputPassword      .ForeColor = foreColor;
                this.ux_inputPassword      .BackColor = Color.Empty;
                this.ux_inputPasswordVerfiy.ForeColor = foreColor;
                this.ux_inputPasswordVerfiy.BackColor = Color.Empty;
                this._messages.RemoveMessage(this.ux_inputPassword);
            }
            else
            {
                errMessage = "The specified input and \"verify\" passwords do not match.";
            }
            if (errMessage != string.Empty)
            {
                this._messages.AddMessage(errMessage, null, Color.Red, this.ux_inputPassword);
                this.ux_inputPassword      .BackColor = Color.Honeydew;
                this.ux_inputPassword      .ForeColor = Color.Red;
                this.ux_inputPasswordVerfiy.BackColor = Color.Honeydew;
                this.ux_inputPasswordVerfiy.ForeColor = Color.Red;
            }
        }
        void InputPassword_EnabledChanged(object sender, EventArgs e)
        {
            TextBox tb = (TextBox)sender;
            if (tb.Enabled) { this.InputPassword_TextChanged(sender, e); }
            else
            {
                this._messages.RemoveMessage(this.ux_inputPassword);
                this.ux_inputPassword      .BackColor = Color.Empty;
                this.ux_inputPasswordVerfiy.BackColor = Color.Empty;
            }
        }
        void InputFile_TextChanged(object sender, EventArgs e)
        {
            TextBox tb                     = (TextBox)sender;
            bool    isMarketData           = (tb == this.ux_marketDataFile);
            bool    isTechnologies         = (tb == this.ux_technologiesFile);
            bool    isParameters           = (tb == this.ux_parametersFile);
            bool    isTailpipeEmissions    = (tb == this.ux_tailpipeEmissionsFile);
            bool    isScenarios            = (tb == this.ux_scenariosFile);
            bool    isEISParameters        = (tb == this.ux_eisParametersFile);
            bool    isEISTailpipeEmissions = (tb == this.ux_eisTailpipeEmissionsFile);
            int     fileID =
                (isMarketData          ) ? MarketDataID :
                (isTechnologies        ) ? TechnologiesID :
                (isParameters          ) ? ParametersID :
                (isTailpipeEmissions   ) ? TailpipeEmissionsID :
                (isScenarios           ) ? ScenariosID :
                (isEISParameters       ) ? EISParametersID :
                (isEISTailpipeEmissions) ? EISTailpipeEmissionsID : -1;
            Label   outdatedLbl =
                (isMarketData          ) ? this.ux_marketDataFileOutdatedLabel :
                (isTechnologies        ) ? this.ux_technologiesFileOutdatedLabel :
                (isParameters          ) ? this.ux_parametersFileOutdatedLabel :
                (isTailpipeEmissions   ) ? this.ux_tailpipeEmissionsFileOutdatedLabel :
                (isScenarios           ) ? this.ux_scenariosFileOutdatedLabel :
                (isEISParameters       ) ? this.ux_eisParametersFileOutdatedLabel :
                (isEISTailpipeEmissions) ? this.ux_eisTailpipeEmissionsFileOutdatedLabel : null;
            if (fileID == -1 || outdatedLbl == null) { return; }
            string filePath = tb.Text.Trim();
            if (filePath != string.Empty && File.Exists(filePath))
            {
                bool inputFilePathChanged =
                    (isMarketData           && !this.CompareFilePaths(this._inputSettings.MarketDataFile          , filePath)) ||
                    (isTechnologies         && !this.CompareFilePaths(this._inputSettings.TechnologiesFile        , filePath)) ||
                    (isParameters           && !this.CompareFilePaths(this._inputSettings.ParametersFile          , filePath)) ||
                    (isTailpipeEmissions    && !this.CompareFilePaths(this._inputSettings.TailpipeEmissionsFile   , filePath)) ||
                    (isScenarios            && !this.CompareFilePaths(this._inputSettings.ScenariosFile           , filePath)) ||
                    (isEISParameters        && !this.CompareFilePaths(this._eisSettings  .EISParametersFile       , filePath)) ||
                    (isEISTailpipeEmissions && !this.CompareFilePaths(this._eisSettings  .EISTailpipeEmissionsFile, filePath));
                tb.ForeColor = (this._visualTracking && inputFilePathChanged) ? this._visualTrackingColor : Control.DefaultForeColor;
                tb.BackColor = Color.Empty;
                this._messages.RemoveMessage(tb);
                if (inputFilePathChanged)
                {   
                    this.BeginParse();
                    if (this.VerifyFile(tb, fileID, this.GetCurrentPassword()))
                    {
                        tb.ForeColor = (this._visualTracking) ? this._visualTrackingColor : Control.DefaultForeColor;
                        tb.BackColor = Color.Empty;
                    }
                    this.EndParse();
                    outdatedLbl.Visible = false;
                } 
            }
            else
            {
                if (filePath == string.Empty)
                {
                    this._messages.AddMessage(
                        "Please select a " + FriendlyTitles[fileID] + " file you would like to use with the model.", null, Color.Red, tb);
                }
                else
                {
                    this._messages.AddMessage(
                        "The specified " + FriendlyTitles[fileID] + " file does not exist on disk.", null, Color.Red, tb);
                }
                tb.BackColor = Color.Honeydew;
                tb.ForeColor = Color.Red;
            }
        }
        void InputFile_VisibleOrEnabledChanged(object sender, EventArgs e)
        {
            TextBox tb = (TextBox)sender;
            if (tb.Enabled && tb.Visible) { this.InputFile_TextChanged(sender, e); }
            else                          { this._messages.RemoveMessage(sender); tb.BackColor = Color.Empty; }
        }
        void InputFileBrowse_Click(object sender, EventArgs e)
        {
            TextBox tb = null;
            int id = -1;
            if      (sender == this.ux_marketDataFileBrowse          ) { id = MarketDataID          ; tb = this.ux_marketDataFile          ; }
            else if (sender == this.ux_technologiesFileBrowse        ) { id = TechnologiesID        ; tb = this.ux_technologiesFile        ; }
            else if (sender == this.ux_parametersFileBrowse          ) { id = ParametersID          ; tb = this.ux_parametersFile          ; }
            else if (sender == this.ux_tailpipeEmissionsFileBrowse   ) { id = TailpipeEmissionsID   ; tb = this.ux_tailpipeEmissionsFile   ; }
            else if (sender == this.ux_scenariosFileBrowse           ) { id = ScenariosID           ; tb = this.ux_scenariosFile           ; }
            else if (sender == this.ux_eisParametersFileBrowse       ) { id = EISParametersID       ; tb = this.ux_eisParametersFile       ; }
            else if (sender == this.ux_eisTailpipeEmissionsFileBrowse) { id = EISTailpipeEmissionsID; tb = this.ux_eisTailpipeEmissionsFile; }
            OpenFileDialog dlg = new OpenFileDialog();
            if (id != -1) { dlg.Title = "Please select the " + FriendlyTitles[id] + " file you would like to use with the model:"; }
            if (File.Exists(tb.Text)) { dlg.FileName = tb.Text; }
            dlg.Multiselect = false;
            dlg.Filter = "Microsoft Excel Workbook Files (*.xls)|*.xls";
            if (dlg.ShowDialog() == DialogResult.OK) { tb.Text = dlg.FileName; }
        }
        bool CompareFilePaths(string path1, string path2)
        {
            if (File.Exists(path1)) { path1 = Path.GetFullPath(path1); }
            if (File.Exists(path2)) { path2 = Path.GetFullPath(path2); }
            return Interaction.StringCompare(path1, path2, false);
        }
        void InitializeInputPanelDragDrop()
        {
            this.ux_inputFilesPanel.AllowDrop = true;
            this.ux_inputFilesPanel.DragEnter += new DragEventHandler(this.InputFilePanel_DragEnter);
            this.ux_inputFilesPanel.DragDrop  += new DragEventHandler(this.InputFilePanel_DragDrop);
        }
        void InputFilePanel_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop, false))
            {
                e.Effect = DragDropEffects.All;
            }
        }
        void InputFilePanel_DragDrop(object sender, DragEventArgs e)
        {
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop, false);
            this.ParseFiles(files, this.GetCurrentPassword(), false);
        }
        void BeginParse()
        {
            this._parsing++;
            if (this._parsing == 1) { this.ChangeInputState(this, EventArgs.Empty); }
        }
        void EndParse()
        {
            if (this._parsing > 0)
            {
                this._parsing--;
                if (this._parsing == 0) { this.ChangeInputState(this, EventArgs.Empty); }
            }
        }
        void ChangeInputState(object sender, EventArgs e)
        {
            this.OnParsingChanged(e);
            if (this.Visible && this.IsHandleCreated)
            {
                if (this.InvokeRequired)
                {
                    this.Invoke(new EventHandler(this.ChangeInputState));
                }
                else
                {
                    bool enabled = (this._parsing == 0);
                    this.AllowDrop                                   =  enabled;
                    this.ux_encryptionPanel               .Enabled   =  enabled;
                    this.ux_inputFilesPanel               .AllowDrop =  enabled;
                    this.ux_marketDataFile                .ReadOnly  = !enabled;
                    this.ux_technologiesFile              .ReadOnly  = !enabled;
                    this.ux_parametersFile                .ReadOnly  = !enabled;
                    this.ux_tailpipeEmissionsFile         .ReadOnly  = !enabled;
                    this.ux_scenariosFile                 .ReadOnly  = !enabled;
                    this.ux_eisParametersFile             .ReadOnly  = !enabled;
                    this.ux_eisTailpipeEmissionsFile      .ReadOnly  = !enabled;
                    this.ux_marketDataFileBrowse          .Enabled   =  enabled;
                    this.ux_technologiesFileBrowse        .Enabled   =  enabled;
                    this.ux_parametersFileBrowse          .Enabled   =  enabled;
                    this.ux_tailpipeEmissionsFileBrowse   .Enabled   =  enabled;
                    this.ux_scenariosFileBrowse           .Enabled   =  enabled;
                    this.ux_eisParametersFileBrowse       .Enabled   =  enabled;
                    this.ux_eisTailpipeEmissionsFileBrowse.Enabled   =  enabled;
                    if (enabled)
                    {
                        this.ux_reloadAllFromDisk.Checked = false;
                    }
                } 
            } 
        }
        void ParseFile(string path, string password, bool keepExisting)
        {
            this.ParseFiles(new string[] {path}, password, keepExisting);
        }
        void ParseFiles(string[] paths, string password, bool keepExisting)
        {
            if (paths == null || paths.Length == 0) { return; }
            this.BeginParse();
            StringCollection scFiles = new StringCollection();
            StringCollection scDirs  = new StringCollection();
            for (int i = 0; i < paths.Length; i++)
            {
                if      (Directory.Exists(paths[i])) { scDirs .Add(paths[i]); }
                else if (File     .Exists(paths[i])) { scFiles.Add(paths[i]); }
            }
            string[] files = new string[scFiles.Count]; scFiles.CopyTo(files, 0);
            string[] dirs  = new string[scDirs .Count]; scDirs .CopyTo(dirs , 0);
            bool[] found = new bool[FileCount];
            if (keepExisting)
            {
                if (File.Exists(this.ux_marketDataFile          .Text)) { found[MarketDataID          ] = true; }
                if (File.Exists(this.ux_technologiesFile        .Text)) { found[TechnologiesID        ] = true; }
                if (File.Exists(this.ux_parametersFile          .Text)) { found[ParametersID          ] = true; }
                if (File.Exists(this.ux_tailpipeEmissionsFile   .Text)) { found[TailpipeEmissionsID   ] = true; }
                if (File.Exists(this.ux_scenariosFile           .Text)) { found[ScenariosID           ] = true; }
                if (File.Exists(this.ux_eisParametersFile       .Text)) { found[EISParametersID       ] = true; }
                if (File.Exists(this.ux_eisTailpipeEmissionsFile.Text)) { found[EISTailpipeEmissionsID] = true; }
            }
            this.ParseFilesHelper(files, dirs, found, password, 3);
            this.EndParse();
        }
        void ParseFilesHelper(string[] files, string[] dirs, bool[] found, string password, int recurseDepth)
        {
            int foundCount = 0;
            for (int i = 0; i < found.Length; i++)
            {
                if (found[i]) { foundCount++; }
            }
            for (int i = 0; i < files.Length; i++)
            {
                if (foundCount == FileCount) { return; }
                this._messages.AddMessage("Checking input file:  \"" + files[i] + "\"", null, Color.Blue, files[i]);
                Application.DoEvents();
                string wbTitle;
                try
                {   
                    Input input = new Input(files[i], password);
                    input.Close();
                    wbTitle = input.Title;
                } catch { continue; }
                for (int j = 0; j < FileCount; j++)
                {
                    if (this._visibleFiles[j] && !found[j] && Interaction.StringCompareAny(wbTitle, DesiredTitles[j], true))
                    {
                        found[j] = true;
                        foundCount++;
                        if      (j == MarketDataID          ) { this.ux_marketDataFile          .Text = files[i]; }
                        else if (j == TechnologiesID        ) { this.ux_technologiesFile        .Text = files[i]; }
                        else if (j == ParametersID          ) { this.ux_parametersFile          .Text = files[i]; }
                        else if (j == TailpipeEmissionsID   ) { this.ux_tailpipeEmissionsFile   .Text = files[i]; }
                        else if (j == ScenariosID           ) { this.ux_scenariosFile           .Text = files[i]; }
                        else if (j == EISParametersID       ) { this.ux_eisParametersFile       .Text = files[i]; }
                        else if (j == EISTailpipeEmissionsID) { this.ux_eisTailpipeEmissionsFile.Text = files[i]; }
                        break;
                    }
                }
                this._messages.RemoveMessage(files[i]);
                Application.DoEvents();
            } 
            for (int i = 0; i < dirs.Length; i++)
            {
                string[] recurseFiles = Directory.GetFiles(dirs[i], "*.xls");
                string[] recurseDirs  = (recurseDepth > 0) ? Directory.GetDirectories(dirs[i]) : new string[0];
                this.ParseFilesHelper(recurseFiles, recurseDirs, found, password, recurseDepth - 1);
            }
        }
        void VerifyFiles()
        {
            this.BeginParse();
            string password = this.GetCurrentPassword();
            this.VerifyFile(this.ux_marketDataFile          , MarketDataID          , password);
            this.VerifyFile(this.ux_technologiesFile        , TechnologiesID        , password);
            this.VerifyFile(this.ux_parametersFile          , ParametersID          , password);
            this.VerifyFile(this.ux_tailpipeEmissionsFile   , TailpipeEmissionsID   , password);
            this.VerifyFile(this.ux_scenariosFile           , ScenariosID           , password);
            this.VerifyFile(this.ux_eisParametersFile       , EISParametersID       , password);
            this.VerifyFile(this.ux_eisTailpipeEmissionsFile, EISTailpipeEmissionsID, password);
            this.EndParse();
        }
        bool VerifyFile(TextBox tb, int fileID, string password)
        {
            this._messages.AddMessage("Checking " + FriendlyTitles[fileID] + " input file ...", null, Color.Blue, tb);
            Application.DoEvents();
            bool verified = false;
            try
            {
                Input inputFile = new Input(tb.Text, password);
                inputFile.Close();
                verified = Interaction.StringCompareAny(inputFile.Title, DesiredTitles[fileID], true);
            }
            catch { verified = false; }
            this._messages.RemoveMessage(tb);
            Application.DoEvents();
            if (!verified)
            {
                this._messages.AddMessage("The selected " + FriendlyTitles[fileID] + " file could not be opened.", null, Color.Red, tb);
                tb.BackColor = Color.Honeydew;
                tb.ForeColor = Color.Red;
                Application.DoEvents();
            }
            return verified;
        }
        void LoadFiles()
        {
            this.BeginParse();
            string password = this.GetCurrentPassword();
            this.LoadFile(MarketDataID          , this.ux_marketDataFile          , password, ref this._inputSettings.MarketDataFile          , ref this._inputSettings.MarketDataTimestamp          );
            this.LoadFile(TechnologiesID        , this.ux_technologiesFile        , password, ref this._inputSettings.TechnologiesFile        , ref this._inputSettings.TechnologiesTimestamp        );
            this.LoadFile(ParametersID          , this.ux_parametersFile          , password, ref this._inputSettings.ParametersFile          , ref this._inputSettings.ParametersTimestamp          );
            this.LoadFile(TailpipeEmissionsID   , this.ux_tailpipeEmissionsFile   , password, ref this._inputSettings.TailpipeEmissionsFile   , ref this._inputSettings.TailpipeEmissionsTimestamp   );
            this.LoadFile(ScenariosID           , this.ux_scenariosFile           , password, ref this._inputSettings.ScenariosFile           , ref this._inputSettings.ScenariosTimestamp           );
            if (this._eisSettings != null)
            {
                this.LoadFile(EISParametersID       , this.ux_eisParametersFile       , password, ref this._eisSettings  .EISParametersFile       , ref this._eisSettings  .EISParametersTimestamp       );
                this.LoadFile(EISTailpipeEmissionsID, this.ux_eisTailpipeEmissionsFile, password, ref this._eisSettings  .EISTailpipeEmissionsFile, ref this._eisSettings  .EISTailpipeEmissionsTimestamp);
            }
            this.EndParse();
        }
        bool LoadFile(int fileID, TextBox tb, string password, ref string file, ref DateTime timestamp)
        {
            if (!this._visibleFiles[fileID]) { return false; }
            if (!(this.ux_reloadAllFromDisk.Checked || !this.CompareFilePaths(file, tb.Text))) { return false; }
            this._messages.AddMessage("Loading " + FriendlyTitles[fileID] + " input file ...", null, Color.Blue, tb);
            Application.DoEvents();
            bool fileLoaded = false;
            string exMessage = string.Empty;
            try
            {
                if      (fileID == MarketDataID          ) { this._data[fileID] = XlParser   .ParseMarketData          (tb.Text, password); }
                else if (fileID == TechnologiesID        ) { this._data[fileID] = XlParser   .ParseTechnologies        (tb.Text, password); }
                else if (fileID == ParametersID          ) { this._data[fileID] = XlParser   .ParseParameters          (tb.Text, password); }
                else if (fileID == TailpipeEmissionsID   ) { this._data[fileID] = XlParser   .ParseTailpipeEmissions   (tb.Text, password); }
                else if (fileID == ScenariosID           ) { this._data[fileID] = XlParser   .ParseScenarios           (tb.Text, password); }
                else if (fileID == EISParametersID       ) { this._data[fileID] = XlEISParser.ParseEISParameters       (tb.Text, password); }
                else if (fileID == EISTailpipeEmissionsID) { this._data[fileID] = XlEISParser.ParseEISTailpipeEmissions(tb.Text, password); }
                file       = tb.Text.Trim();
                timestamp  = File.GetLastWriteTime(file);
                fileLoaded = true;
            }
            catch (Exception ex) { exMessage = ex.Message; fileLoaded = false; }
            this._messages.RemoveMessage(tb);
            Application.DoEvents();
            if (!fileLoaded)
            {
                this._data[fileID] = null;
                this._messages.AddMessage("The selected " + FriendlyTitles[fileID] + " file could not be opened.", exMessage, Color.Red, tb);
                tb.BackColor = Color.Honeydew;
                tb.ForeColor = Color.Red;
            }
            this._loadFailed[fileID] = !fileLoaded;
            return fileLoaded;
        }
        string GetCurrentPassword()
        {
            return (this.ux_encryptInput.Checked &&
                this.ux_inputPassword.Text == this.ux_inputPasswordVerfiy.Text) ? this.ux_inputPassword.Text : null;
        }
        void ShowHideFilePaths()
        {
            if (!this.Visible) { return; }
            int[] pt = new int[FileCount + 1];
            pt[0] = 8;
            for (int i = 0; i < FileCount + 1; i++) { pt[i] = 8 + i * 40; }
            bool showAny = false;
            for (int i = 1; i < FileCount + 1; i++)
            {
                pt[i] = (this._visibleFiles[i - 1]) ? pt[i - 1] + 40 : pt[i - 1];
                if (this._visibleFiles[i - 1]) { showAny = true; }
            }
            if (!this._visibleFiles[MarketDataID]) { this.ux_marketDataFileOutdatedLabel.Visible = false; }
            this.ux_marketDataFileLabel                  .Visible = this._visibleFiles[MarketDataID];
            this.ux_marketDataFile                       .Visible = this._visibleFiles[MarketDataID];
            this.ux_marketDataFileBrowse                 .Visible = this._visibleFiles[MarketDataID];
            if (!this._visibleFiles[TechnologiesID]) { this.ux_technologiesFileOutdatedLabel.Visible = false; }
            this.ux_technologiesFileLabel                .Visible = this._visibleFiles[TechnologiesID];
            this.ux_technologiesFile                     .Visible = this._visibleFiles[TechnologiesID];
            this.ux_technologiesFileBrowse               .Visible = this._visibleFiles[TechnologiesID];
            this.ux_technologiesFileLabel                .Top     = pt[1];
            this.ux_technologiesFileOutdatedLabel        .Top     = pt[1];
            this.ux_technologiesFile                     .Top     = pt[1] + 16;
            this.ux_technologiesFileBrowse               .Top     = pt[1] + 16;
            if (!this._visibleFiles[ParametersID]) { this.ux_parametersFileOutdatedLabel.Visible = false; }
            this.ux_parametersFileLabel                  .Visible = this._visibleFiles[ParametersID];
            this.ux_parametersFile                       .Visible = this._visibleFiles[ParametersID];
            this.ux_parametersFileBrowse                 .Visible = this._visibleFiles[ParametersID];
            this.ux_parametersFileLabel                  .Top     = pt[2];
            this.ux_parametersFileOutdatedLabel          .Top     = pt[2];
            this.ux_parametersFile                       .Top     = pt[2] + 16;
            this.ux_parametersFileBrowse                 .Top     = pt[2] + 16;
            if (!this._visibleFiles[TailpipeEmissionsID]) { this.ux_tailpipeEmissionsFileOutdatedLabel.Visible = false; }
            this.ux_tailpipeEmissionsFileLabel           .Visible = this._visibleFiles[TailpipeEmissionsID];
            this.ux_tailpipeEmissionsFile                .Visible = this._visibleFiles[TailpipeEmissionsID];
            this.ux_tailpipeEmissionsFileBrowse          .Visible = this._visibleFiles[TailpipeEmissionsID];
            this.ux_tailpipeEmissionsFileLabel           .Top     = pt[3];
            this.ux_tailpipeEmissionsFileOutdatedLabel   .Top     = pt[3];
            this.ux_tailpipeEmissionsFile                .Top     = pt[3] + 16;
            this.ux_tailpipeEmissionsFileBrowse          .Top     = pt[3] + 16;
            if (!this._visibleFiles[ScenariosID]) { this.ux_scenariosFileOutdatedLabel.Visible = false; }
            this.ux_scenariosFileLabel                   .Visible = this._visibleFiles[ScenariosID];
            this.ux_scenariosFile                        .Visible = this._visibleFiles[ScenariosID];
            this.ux_scenariosFileBrowse                  .Visible = this._visibleFiles[ScenariosID];
            this.ux_scenariosFileLabel                   .Top     = pt[4];
            this.ux_scenariosFileOutdatedLabel           .Top     = pt[4];
            this.ux_scenariosFile                        .Top     = pt[4] + 16;
            this.ux_scenariosFileBrowse                  .Top     = pt[4] + 16;
            if (!this._visibleFiles[EISParametersID]) { this.ux_eisParametersFileOutdatedLabel.Visible = false; }
            this.ux_eisParametersFileLabel               .Visible = this._visibleFiles[EISParametersID];
            this.ux_eisParametersFile                    .Visible = this._visibleFiles[EISParametersID];
            this.ux_eisParametersFileBrowse              .Visible = this._visibleFiles[EISParametersID];
            this.ux_eisParametersFileLabel               .Top     = pt[5];
            this.ux_eisParametersFileOutdatedLabel       .Top     = pt[5];
            this.ux_eisParametersFile                    .Top     = pt[5] + 16;
            this.ux_eisParametersFileBrowse              .Top     = pt[5] + 16;
            if (!this._visibleFiles[EISTailpipeEmissionsID]) { this.ux_eisTailpipeEmissionsFileOutdatedLabel.Visible = false; }
            this.ux_eisTailpipeEmissionsFileLabel        .Visible = this._visibleFiles[EISTailpipeEmissionsID];
            this.ux_eisTailpipeEmissionsFile             .Visible = this._visibleFiles[EISTailpipeEmissionsID];
            this.ux_eisTailpipeEmissionsFileBrowse       .Visible = this._visibleFiles[EISTailpipeEmissionsID];
            this.ux_eisTailpipeEmissionsFileLabel        .Top     = pt[6];
            this.ux_eisTailpipeEmissionsFileOutdatedLabel.Top     = pt[6];
            this.ux_eisTailpipeEmissionsFile             .Top     = pt[6] + 16;
            this.ux_eisTailpipeEmissionsFileBrowse       .Top     = pt[6] + 16;
            this.ux_reloadAllFromDisk                    .Visible = showAny;
            this.ux_reloadAllFromDisk                    .Top     = pt[7];
            this.ux_inputFilesPanel                      .Height  = pt[7] + 24;
        }
        public void SetInitialState(InputSettings inputSettings, EISSettings eisSettings)
        {
            this._inputSettings = inputSettings;
            this._eisSettings   = eisSettings;
            bool forceReload = false;
            this.ux_doNotEncryptInput  .Checked = !inputSettings.EncryptInput;
            this.ux_encryptInput       .Checked =  inputSettings.EncryptInput;
            this.ux_inputPassword      .Text    =  inputSettings.InputPassword;
            this.ux_inputPasswordVerfiy.Text    =  inputSettings.InputPassword;
            this.SetInitialState_ProcessFile(inputSettings.MarketDataFile       , inputSettings.MarketDataTimestamp       , MarketDataID       , this.ux_marketDataFile       , this.ux_marketDataFileOutdatedLabel       , ref forceReload);
            this.SetInitialState_ProcessFile(inputSettings.TechnologiesFile     , inputSettings.TechnologiesTimestamp     , TechnologiesID     , this.ux_technologiesFile     , this.ux_technologiesFileOutdatedLabel     , ref forceReload);
            this.SetInitialState_ProcessFile(inputSettings.ParametersFile       , inputSettings.ParametersTimestamp       , ParametersID       , this.ux_parametersFile       , this.ux_parametersFileOutdatedLabel       , ref forceReload);
            this.SetInitialState_ProcessFile(inputSettings.TailpipeEmissionsFile, inputSettings.TailpipeEmissionsTimestamp, TailpipeEmissionsID, this.ux_tailpipeEmissionsFile, this.ux_tailpipeEmissionsFileOutdatedLabel, ref forceReload);
            this.SetInitialState_ProcessFile(inputSettings.ScenariosFile        , inputSettings.ScenariosTimestamp        , ScenariosID        , this.ux_scenariosFile        , this.ux_scenariosFileOutdatedLabel        , ref forceReload);
            if (eisSettings == null)
            {
                this.ShowEISParameters        = false;
                this.ShowEISTailpipeEmissions = false;
            }
            else
            {
                this.SetInitialState_ProcessFile(eisSettings.EISParametersFile       , eisSettings.EISParametersTimestamp       , EISParametersID       , this.ux_eisParametersFile       , this.ux_eisParametersFileOutdatedLabel       , ref forceReload);
                this.SetInitialState_ProcessFile(eisSettings.EISTailpipeEmissionsFile, eisSettings.EISTailpipeEmissionsTimestamp, EISTailpipeEmissionsID, this.ux_eisTailpipeEmissionsFile, this.ux_eisTailpipeEmissionsFileOutdatedLabel, ref forceReload);
            }
            this.ux_reloadAllFromDisk.Checked = forceReload;
            this.ShowHideFilePaths();
            base.SaveChanges();
        }
        void SetInitialState_ProcessFile(string file, DateTime timestamp, int fileID, TextBox tb, Label outdatedLbl, ref bool forceReload)
        {
            if (!this._visibleFiles[fileID]) { return; }
            tb.Text = file;
            Application.DoEvents();
            if (File.Exists(file))
            {
                DateTime dt = File.GetLastWriteTime(file);
                if (timestamp < dt)
                {
                    outdatedLbl.Visible = true;
                    forceReload = true;
                }
            }
        }
        public override void SaveChanges()
        {
            if (this.SettingsChanged)
            {   
                this._inputSettings.EncryptInput = this.ux_encryptInput.Checked;
                if (this._inputSettings.EncryptInput)
                {
                    this._inputSettings.InputPassword = this.ux_inputPassword.Text;
                }
                this._saveThread = new Thread(new ThreadStart(this.SaveChangesThread));
                this._saveThread.Name = "InputPanelSaveThread";
                this._saveThread.Start();
            }
        }
        void SaveChangesThread()
        {
            this.LoadFiles();       
            base.SaveChanges();     
            this.PostSave();        
        }
        void PostSave()
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new EmptyEventHandler(this.PostSave));
            }
            else if (this._visualTracking)
            {   
                this.ux_inputPassword      .ForeColor = Control.DefaultForeColor;
                this.ux_inputPassword      .BackColor = Color  .Empty;
                this.ux_inputPasswordVerfiy.ForeColor = Control.DefaultForeColor;
                this.ux_inputPasswordVerfiy.BackColor = Color  .Empty;
                if (!this._loadFailed[MarketDataID])
                {
                    this.ux_marketDataFile.ForeColor = Control.DefaultForeColor;
                    this.ux_marketDataFile.BackColor = Color  .Empty;
                }
                if (!this._loadFailed[TechnologiesID])
                {
                    this.ux_technologiesFile.ForeColor = Control.DefaultForeColor;
                    this.ux_technologiesFile.BackColor = Color  .Empty;
                }
                if (!this._loadFailed[ParametersID])
                {
                    this.ux_parametersFile.ForeColor = Control.DefaultForeColor;
                    this.ux_parametersFile.BackColor = Color  .Empty;
                }
                if (!this._loadFailed[TailpipeEmissionsID])
                {
                    this.ux_tailpipeEmissionsFile.ForeColor = Control.DefaultForeColor;
                    this.ux_tailpipeEmissionsFile.BackColor = Color  .Empty;
                }
                if (!this._loadFailed[ScenariosID])
                {
                    this.ux_scenariosFile.ForeColor = Control.DefaultForeColor;
                    this.ux_scenariosFile.BackColor = Color  .Empty;
                }
                if (!this._loadFailed[EISParametersID])
                {
                    this.ux_eisParametersFile.ForeColor = Control.DefaultForeColor;
                    this.ux_eisParametersFile.BackColor = Color  .Empty;
                }
                if (!this._loadFailed[EISTailpipeEmissionsID])
                {
                    this.ux_eisTailpipeEmissionsFile.ForeColor = Control.DefaultForeColor;
                    this.ux_eisTailpipeEmissionsFile.BackColor = Color  .Empty;
                }
                this.ux_marketDataFileOutdatedLabel          .Visible = false;
                this.ux_technologiesFileOutdatedLabel        .Visible = false;
                this.ux_parametersFileOutdatedLabel          .Visible = false;
                this.ux_tailpipeEmissionsFileOutdatedLabel   .Visible = false;
                this.ux_scenariosFileOutdatedLabel           .Visible = false;
                this.ux_eisParametersFileOutdatedLabel       .Visible = false;
                this.ux_eisTailpipeEmissionsFileOutdatedLabel.Visible = false;
            }
        }
        #endregion
        #region 
        [Browsable(true)]
        [DefaultValue(true)]
        [Category("Appearance")]
        [Description("Specifies whether to display the Market-Data file prompt.")]
        public bool ShowMarketData
        {
            get { return this._visibleFiles[MarketDataID]; }
            set { this._visibleFiles[MarketDataID] = value; this.ShowHideFilePaths(); }
        }
        [Browsable(true)]
        [DefaultValue(true)]
        [Category("Appearance")]
        [Description("Specifies whether to display the Technologies file prompt.")]
        public bool ShowTechnologies
        {
            get { return this._visibleFiles[TechnologiesID]; }
            set { this._visibleFiles[TechnologiesID] = value; this.ShowHideFilePaths(); }
        }
        [Browsable(true)]
        [DefaultValue(true)]
        [Category("Appearance")]
        [Description("Specifies whether to display the Parameters file prompt.")]
        public bool ShowParameters
        {
            get { return this._visibleFiles[ParametersID]; }
            set { this._visibleFiles[ParametersID] = value; this.ShowHideFilePaths(); }
        }
        [Browsable(true)]
        [DefaultValue(true)]
        [Category("Appearance")]
        [Description("Specifies whether to display the Tailpipe Emission Rates file prompt.")]
        public bool ShowTailpipeEmissions
        {
            get { return this._visibleFiles[TailpipeEmissionsID]; }
            set { this._visibleFiles[TailpipeEmissionsID] = value; this.ShowHideFilePaths(); }
        }
        [Browsable(true)]
        [DefaultValue(true)]
        [Category("Appearance")]
        [Description("Specifies whether to display the Scenarios file prompt.")]
        public bool ShowScenarios
        {
            get { return this._visibleFiles[ScenariosID]; }
            set { this._visibleFiles[ScenariosID] = value; this.ShowHideFilePaths(); }
        }
        [Browsable(true)]
        [DefaultValue(true)]
        [Category("Appearance")]
        [Description("Specifies whether to display the EIS Parameters file prompt.")]
        public bool ShowEISParameters
        {
            get { return this._visibleFiles[EISParametersID]; }
            set { this._visibleFiles[EISParametersID] = value; this.ShowHideFilePaths(); }
        }
        [Browsable(true)]
        [DefaultValue(true)]
        [Category("Appearance")]
        [Description("Specifies whether to display the EIS Tailpipe Emission Rates file prompt.")]
        public bool ShowEISTailpipeEmissions
        {
            get { return this._visibleFiles[EISTailpipeEmissionsID]; }
            set { this._visibleFiles[EISTailpipeEmissionsID] = value; this.ShowHideFilePaths(); }
        }
        [Browsable(false)]
        public Industry MarketData
        {
            get { return (this._data[MarketDataID] == null) ? null : (Industry)this._data[MarketDataID]; }
        }
        [Browsable(false)]
        public List<Technology> Technologies
        {
            get { return (this._data[TechnologiesID] == null) ? null : (List<Technology>)this._data[TechnologiesID]; }
        }
        [Browsable(false)]
        public Parameters Parameters
        {
            get { return (this._data[ParametersID] == null) ? null : (Parameters)this._data[ParametersID]; }
        }
        [Browsable(false)]
        public TailpipeEmissions TailpipeEmissions
        {
            get { return (this._data[TailpipeEmissionsID] == null) ? null : (TailpipeEmissions)this._data[TailpipeEmissionsID]; }
        }
        [Browsable(false)]
        public List<Scenario> Scenarios
        {
            get { return (this._data[ScenariosID] == null) ? null : (List<Scenario>)this._data[ScenariosID]; }
        }
        [Browsable(false)]
        public EISParameters EISParameters
        {
            get { return (this._data[EISParametersID] == null) ? null : (EISParameters)this._data[EISParametersID]; }
        }
        [Browsable(false)]
        public EISTailpipeEmissions EISTailpipeEmissions
        {
            get { return (this._data[EISTailpipeEmissionsID] == null) ? null : (EISTailpipeEmissions)this._data[EISTailpipeEmissionsID]; }
        }
        [Browsable(false)]
        public bool Parsing { get { return this._parsing > 0; } }
        [Browsable(false)]
        public override bool SettingsChanged
        {
            get
            {
                if (this.Parsing) { return false; }     
                if (this.ux_encryptInput.Checked &&
                    (this.ux_inputPassword.Text == string.Empty ||
                     this.ux_inputPassword.Text != this.ux_inputPasswordVerfiy.Text)) { return false; }
                if ((this._visibleFiles[MarketDataID          ] && !File.Exists(this.ux_marketDataFile          .Text)) ||
                    (this._visibleFiles[TechnologiesID        ] && !File.Exists(this.ux_technologiesFile        .Text)) ||
                    (this._visibleFiles[ParametersID          ] && !File.Exists(this.ux_parametersFile          .Text)) ||
                    (this._visibleFiles[TailpipeEmissionsID   ] && !File.Exists(this.ux_tailpipeEmissionsFile   .Text)) ||
                    (this._visibleFiles[ScenariosID           ] && !File.Exists(this.ux_scenariosFile           .Text)) ||
                    (this._visibleFiles[EISParametersID       ] && !File.Exists(this.ux_eisParametersFile       .Text)) ||
                    (this._visibleFiles[EISTailpipeEmissionsID] && !File.Exists(this.ux_eisTailpipeEmissionsFile.Text))) { return false; }
                return base.SettingsChanged ||
                    (this.ux_encryptInput.Checked && this.ux_inputPassword.Text != this._inputSettings.InputPassword) ||
                    this.ux_reloadAllFromDisk.Checked ||
                    (this._visibleFiles[MarketDataID          ] && !this.CompareFilePaths(this._inputSettings.MarketDataFile          , this.ux_marketDataFile          .Text)) ||
                    (this._visibleFiles[TechnologiesID        ] && !this.CompareFilePaths(this._inputSettings.TechnologiesFile        , this.ux_technologiesFile        .Text)) ||
                    (this._visibleFiles[ParametersID          ] && !this.CompareFilePaths(this._inputSettings.ParametersFile          , this.ux_parametersFile          .Text)) ||
                    (this._visibleFiles[TailpipeEmissionsID   ] && !this.CompareFilePaths(this._inputSettings.TailpipeEmissionsFile   , this.ux_tailpipeEmissionsFile   .Text)) ||
                    (this._visibleFiles[ScenariosID           ] && !this.CompareFilePaths(this._inputSettings.ScenariosFile           , this.ux_scenariosFile           .Text)) ||
                    (this._visibleFiles[EISParametersID       ] && !this.CompareFilePaths(this._eisSettings  .EISParametersFile       , this.ux_eisParametersFile       .Text)) ||
                    (this._visibleFiles[EISTailpipeEmissionsID] && !this.CompareFilePaths(this._eisSettings  .EISTailpipeEmissionsFile, this.ux_eisTailpipeEmissionsFile.Text));
            }
        }
        #endregion
        #region 
        #region 
        Label       ux_encryptionLabel;
        Panel       ux_encryptionPanel;
        RadioButton ux_encryptInput;
        RadioButton ux_doNotEncryptInput;
        TextBox     ux_inputPassword;
        Label       ux_inputPasswordLabel1;
        TextBox     ux_inputPasswordVerfiy;
        Label       ux_inputPasswordLabel2;
        Label       ux_inputPasswordLabel3;
        Label   ux_inputFilesLabel;
        Panel   ux_inputFilesPanel;
        Label   ux_marketDataFileLabel;
        Label   ux_marketDataFileOutdatedLabel;
        TextBox ux_marketDataFile;
        Button  ux_marketDataFileBrowse;
        Label   ux_technologiesFileLabel;
        Label   ux_technologiesFileOutdatedLabel;
        TextBox ux_technologiesFile;
        Button  ux_technologiesFileBrowse;
        Label   ux_parametersFileLabel;
        Label   ux_parametersFileOutdatedLabel;
        TextBox ux_parametersFile;
        Button  ux_parametersFileBrowse;
        Label   ux_tailpipeEmissionsFileLabel;
        Label   ux_tailpipeEmissionsFileOutdatedLabel;
        TextBox ux_tailpipeEmissionsFile;
        Button  ux_tailpipeEmissionsFileBrowse;
        Label   ux_scenariosFileLabel;
        Label   ux_scenariosFileOutdatedLabel;
        TextBox ux_scenariosFile;
        Button  ux_scenariosFileBrowse;
        Label   ux_eisParametersFileLabel;
        Label   ux_eisParametersFileOutdatedLabel;
        TextBox ux_eisParametersFile;
        Button  ux_eisParametersFileBrowse;
        Label   ux_eisTailpipeEmissionsFileLabel;
        Label   ux_eisTailpipeEmissionsFileOutdatedLabel;
        TextBox ux_eisTailpipeEmissionsFile;
        Button  ux_eisTailpipeEmissionsFileBrowse;
        CheckBox ux_reloadAllFromDisk;
        #endregion
        static readonly string[][] DesiredTitles =
            new string[][] {
                               new string[] {"CAFE Market Data"},
                               new string[] {"CAFE Technologies"},
                               new string[] {"CAFE Parameters"},
                               new string[] {"CAFE Tailpipe Emission Rates", "CAFE Tailpipe Emissions"},
                               new string[] {"CAFE Scenarios"},
                               new string[] {"EIS Parameters"},
                               new string[] {"EIS Tailpipe Emission Rates", "EIS Tailpipe Emissions"}
                           };
        static readonly string[] FriendlyTitles =
            new string[] {
                             "Market-Data",
                             "Technologies",
                             "Parameters",
                             "Tailpipe Emission Rates",
                             "Scenarios",
                             "EIS Parameters",
                             "EIS Tailpipe Emission Rates"
                         };
        const int FileCount              = 7;   
        const int MarketDataID           = 0;
        const int TechnologiesID         = 1;
        const int ParametersID           = 2;
        const int TailpipeEmissionsID    = 3;
        const int ScenariosID            = 4;
        const int EISParametersID        = 5;
        const int EISTailpipeEmissionsID = 6;
        int    _parsing;                        
        Thread _saveThread;                     
        bool  [] _visibleFiles;                 
        bool  [] _verifiedFiles;                
        bool  [] _loadFailed;                   
        object[] _data;                         
        InputSettings _inputSettings;
        EISSettings _eisSettings;
        #endregion
    }
}

