using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Volpe.Cafe;
using Volpe.Cafe.Optimization.Settings;
using Volpe.Cafe.Settings;
using Volpe.Cafe.Utils;
namespace Volpe.Cafe.UI.Panels
{
    public class OptimizationPanel : CafeUserControl
    {
        #region 
        public OptimizationPanel()
        {
            this.InitializeComponent();
            this.PostInitialize();
        }
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }
        #endregion
        #region 
        #region 
        void InitializeComponent()
        {
            this.ux_typeLabel = new System.Windows.Forms.Label();
            this.ux_typePanel = new System.Windows.Forms.Panel();
            this.ux_typeDefault = new System.Windows.Forms.RadioButton();
            this.ux_typeLightTruck = new System.Windows.Forms.RadioButton();
            this.ux_typePassengerAuto = new System.Windows.Forms.RadioButton();
            this.ux_modeLabel = new System.Windows.Forms.Label();
            this.ux_modePanel = new System.Windows.Forms.Panel();
            this.ux_modeZeroNetBenefits = new System.Windows.Forms.RadioButton();
            this.ux_modeMaximumNetBenefits = new System.Windows.Forms.RadioButton();
            this.ux_iterationOptionsLabel = new System.Windows.Forms.Label();
            this.ux_iterationOptionsPanel = new System.Windows.Forms.Panel();
            this.ux_iterationAboveOptimum = new System.Windows.Forms.TextBox();
            this.ux_iterationBelowOptimum = new System.Windows.Forms.TextBox();
            this.ux_iterationIncrement = new System.Windows.Forms.TextBox();
            this.ux_iterationIncrementLabel = new System.Windows.Forms.Label();
            this.ux_iterationBelowOptimumLabel = new System.Windows.Forms.Label();
            this.ux_iterationAboveOptimumLabel = new System.Windows.Forms.Label();
            this.ux_optStartYear = new System.Windows.Forms.TextBox();
            this.ux_optUseStartYear = new System.Windows.Forms.CheckBox();
            this.ux_typePanel.SuspendLayout();
            this.ux_modePanel.SuspendLayout();
            this.ux_iterationOptionsPanel.SuspendLayout();
            this.SuspendLayout();
            this.ux_typeLabel.AutoSize = true;
            this.ux_typeLabel.Location = new System.Drawing.Point(8, 8);
            this.ux_typeLabel.Name = "ux_typeLabel";
            this.ux_typeLabel.Size = new System.Drawing.Size(162, 13);
            this.ux_typeLabel.TabIndex = 0;
            this.ux_typeLabel.Text = "What would you like to optimize?";
            this.ux_typePanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_typePanel.Controls.Add(this.ux_typeDefault);
            this.ux_typePanel.Controls.Add(this.ux_typeLightTruck);
            this.ux_typePanel.Controls.Add(this.ux_typePassengerAuto);
            this.ux_typePanel.Location = new System.Drawing.Point(8, 16);
            this.ux_typePanel.Name = "ux_typePanel";
            this.ux_typePanel.Size = new System.Drawing.Size(424, 56);
            this.ux_typePanel.TabIndex = 1;
            this.ux_typeDefault.AutoSize = true;
            this.ux_typeDefault.Checked = true;
            this.ux_typeDefault.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_typeDefault.Location = new System.Drawing.Point(8, 40);
            this.ux_typeDefault.Name = "ux_typeDefault";
            this.ux_typeDefault.Size = new System.Drawing.Size(247, 17);
            this.ux_typeDefault.TabIndex = 2;
            this.ux_typeDefault.TabStop = true;
            this.ux_typeDefault.Text = "Auto-detect based on the market data (default).";
            this.ux_typeLightTruck.AutoSize = true;
            this.ux_typeLightTruck.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_typeLightTruck.Location = new System.Drawing.Point(8, 24);
            this.ux_typeLightTruck.Name = "ux_typeLightTruck";
            this.ux_typeLightTruck.Size = new System.Drawing.Size(60, 17);
            this.ux_typeLightTruck.TabIndex = 1;
            this.ux_typeLightTruck.Text = "Trucks,";
            this.ux_typePassengerAuto.AutoSize = true;
            this.ux_typePassengerAuto.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_typePassengerAuto.Location = new System.Drawing.Point(8, 8);
            this.ux_typePassengerAuto.Name = "ux_typePassengerAuto";
            this.ux_typePassengerAuto.Size = new System.Drawing.Size(48, 17);
            this.ux_typePassengerAuto.TabIndex = 0;
            this.ux_typePassengerAuto.Text = "Cars,";
            this.ux_modeLabel.AutoSize = true;
            this.ux_modeLabel.Location = new System.Drawing.Point(8, 76);
            this.ux_modeLabel.Name = "ux_modeLabel";
            this.ux_modeLabel.Size = new System.Drawing.Size(233, 13);
            this.ux_modeLabel.TabIndex = 2;
            this.ux_modeLabel.Text = "Which optimization mode would you like to use?";
            this.ux_modePanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_modePanel.Controls.Add(this.ux_modeZeroNetBenefits);
            this.ux_modePanel.Controls.Add(this.ux_modeMaximumNetBenefits);
            this.ux_modePanel.Location = new System.Drawing.Point(8, 84);
            this.ux_modePanel.Name = "ux_modePanel";
            this.ux_modePanel.Size = new System.Drawing.Size(424, 44);
            this.ux_modePanel.TabIndex = 3;
            this.ux_modeZeroNetBenefits.AutoSize = true;
            this.ux_modeZeroNetBenefits.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_modeZeroNetBenefits.Location = new System.Drawing.Point(8, 24);
            this.ux_modeZeroNetBenefits.Name = "ux_modeZeroNetBenefits";
            this.ux_modeZeroNetBenefits.Size = new System.Drawing.Size(348, 17);
            this.ux_modeZeroNetBenefits.TabIndex = 1;
            this.ux_modeZeroNetBenefits.Text = "Optimize by minimizing Net Benefits, after the maximum has occurred,";
            this.ux_modeMaximumNetBenefits.AutoSize = true;
            this.ux_modeMaximumNetBenefits.Checked = true;
            this.ux_modeMaximumNetBenefits.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_modeMaximumNetBenefits.Location = new System.Drawing.Point(8, 8);
            this.ux_modeMaximumNetBenefits.Name = "ux_modeMaximumNetBenefits";
            this.ux_modeMaximumNetBenefits.Size = new System.Drawing.Size(262, 17);
            this.ux_modeMaximumNetBenefits.TabIndex = 0;
            this.ux_modeMaximumNetBenefits.TabStop = true;
            this.ux_modeMaximumNetBenefits.Text = "Optimize based on maximum Net Benefits (default),";
            this.ux_iterationOptionsLabel.AutoSize = true;
            this.ux_iterationOptionsLabel.Location = new System.Drawing.Point(8, 132);
            this.ux_iterationOptionsLabel.Name = "ux_iterationOptionsLabel";
            this.ux_iterationOptionsLabel.Size = new System.Drawing.Size(219, 13);
            this.ux_iterationOptionsLabel.TabIndex = 4;
            this.ux_iterationOptionsLabel.Text = "Please specify options for iterating the model:";
            this.ux_iterationOptionsPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.ux_iterationOptionsPanel.Controls.Add(this.ux_iterationAboveOptimum);
            this.ux_iterationOptionsPanel.Controls.Add(this.ux_iterationBelowOptimum);
            this.ux_iterationOptionsPanel.Controls.Add(this.ux_iterationIncrement);
            this.ux_iterationOptionsPanel.Controls.Add(this.ux_iterationIncrementLabel);
            this.ux_iterationOptionsPanel.Controls.Add(this.ux_iterationBelowOptimumLabel);
            this.ux_iterationOptionsPanel.Controls.Add(this.ux_iterationAboveOptimumLabel);
            this.ux_iterationOptionsPanel.Location = new System.Drawing.Point(8, 140);
            this.ux_iterationOptionsPanel.Name = "ux_iterationOptionsPanel";
            this.ux_iterationOptionsPanel.Size = new System.Drawing.Size(424, 68);
            this.ux_iterationOptionsPanel.TabIndex = 5;
            this.ux_iterationAboveOptimum.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_iterationAboveOptimum.Location = new System.Drawing.Point(216, 8);
            this.ux_iterationAboveOptimum.Multiline = true;
            this.ux_iterationAboveOptimum.Name = "ux_iterationAboveOptimum";
            this.ux_iterationAboveOptimum.Size = new System.Drawing.Size(56, 18);
            this.ux_iterationAboveOptimum.TabIndex = 1;
            this.ux_iterationAboveOptimum.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.ux_iterationAboveOptimum.WordWrap = false;
            this.ux_iterationBelowOptimum.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_iterationBelowOptimum.Location = new System.Drawing.Point(216, 28);
            this.ux_iterationBelowOptimum.Multiline = true;
            this.ux_iterationBelowOptimum.Name = "ux_iterationBelowOptimum";
            this.ux_iterationBelowOptimum.Size = new System.Drawing.Size(56, 18);
            this.ux_iterationBelowOptimum.TabIndex = 3;
            this.ux_iterationBelowOptimum.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.ux_iterationBelowOptimum.WordWrap = false;
            this.ux_iterationIncrement.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_iterationIncrement.Location = new System.Drawing.Point(216, 48);
            this.ux_iterationIncrement.Multiline = true;
            this.ux_iterationIncrement.Name = "ux_iterationIncrement";
            this.ux_iterationIncrement.Size = new System.Drawing.Size(56, 18);
            this.ux_iterationIncrement.TabIndex = 5;
            this.ux_iterationIncrement.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.ux_iterationIncrement.WordWrap = false;
            this.ux_iterationIncrementLabel.AutoSize = true;
            this.ux_iterationIncrementLabel.Location = new System.Drawing.Point(8, 48);
            this.ux_iterationIncrementLabel.Name = "ux_iterationIncrementLabel";
            this.ux_iterationIncrementLabel.Size = new System.Drawing.Size(71, 13);
            this.ux_iterationIncrementLabel.TabIndex = 4;
            this.ux_iterationIncrementLabel.Text = "Increment by:";
            this.ux_iterationIncrementLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.ux_iterationBelowOptimumLabel.AutoSize = true;
            this.ux_iterationBelowOptimumLabel.Location = new System.Drawing.Point(8, 28);
            this.ux_iterationBelowOptimumLabel.Name = "ux_iterationBelowOptimumLabel";
            this.ux_iterationBelowOptimumLabel.Size = new System.Drawing.Size(201, 13);
            this.ux_iterationBelowOptimumLabel.TabIndex = 2;
            this.ux_iterationBelowOptimumLabel.Text = "Iterations below optimum (more stringent):";
            this.ux_iterationBelowOptimumLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.ux_iterationAboveOptimumLabel.AutoSize = true;
            this.ux_iterationAboveOptimumLabel.Location = new System.Drawing.Point(8, 8);
            this.ux_iterationAboveOptimumLabel.Name = "ux_iterationAboveOptimumLabel";
            this.ux_iterationAboveOptimumLabel.Size = new System.Drawing.Size(198, 13);
            this.ux_iterationAboveOptimumLabel.TabIndex = 0;
            this.ux_iterationAboveOptimumLabel.Text = "Iterations above optimum (less stringent):";
            this.ux_iterationAboveOptimumLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.ux_optStartYear.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ux_optStartYear.Location = new System.Drawing.Point(256, 212);
            this.ux_optStartYear.MaxLength = 4;
            this.ux_optStartYear.Multiline = true;
            this.ux_optStartYear.Name = "ux_optStartYear";
            this.ux_optStartYear.Size = new System.Drawing.Size(56, 18);
            this.ux_optStartYear.TabIndex = 4;
            this.ux_optStartYear.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.ux_optUseStartYear.AutoSize = true;
            this.ux_optUseStartYear.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_optUseStartYear.Location = new System.Drawing.Point(8, 212);
            this.ux_optUseStartYear.Name = "ux_optUseStartYear";
            this.ux_optUseStartYear.Size = new System.Drawing.Size(248, 17);
            this.ux_optUseStartYear.TabIndex = 3;
            this.ux_optUseStartYear.Text = "Begin optimizing starting with the specified year:";
            this.Controls.Add(this.ux_optStartYear);
            this.Controls.Add(this.ux_iterationOptionsLabel);
            this.Controls.Add(this.ux_optUseStartYear);
            this.Controls.Add(this.ux_iterationOptionsPanel);
            this.Controls.Add(this.ux_modeLabel);
            this.Controls.Add(this.ux_modePanel);
            this.Controls.Add(this.ux_typeLabel);
            this.Controls.Add(this.ux_typePanel);
            this.MinimumSize = new System.Drawing.Size(440, 0);
            this.Name = "OptimizationPanel";
            this.Size = new System.Drawing.Size(440, 240);
            this.ux_typePanel.ResumeLayout(false);
            this.ux_typePanel.PerformLayout();
            this.ux_modePanel.ResumeLayout(false);
            this.ux_modePanel.PerformLayout();
            this.ux_iterationOptionsPanel.ResumeLayout(false);
            this.ux_iterationOptionsPanel.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();
        }
        #endregion
        void PostInitialize()
        {
            this.AutoInitializeCheckChangesDetector(this.Controls);
            this.RegisterNumericTextControl(this.ux_iterationAboveOptimum, 100.0    , 0.0    , 1000.0    , "The number of iterations above optimum should be between {MIN} and {MAX}.", true, "0"      );
            this.RegisterNumericTextControl(this.ux_iterationBelowOptimum, 100.0    , 0.0    , 1000.0    , "The number of iterations below optimum should be between {MIN} and {MAX}.", true, "0"      );
            this.RegisterNumericTextControl(this.ux_iterationIncrement   ,   0.00010, 0.00001,    0.10000, "The iteration increment should be between {MIN} and {MAX}."          , true, "0.00000");
            this.ux_optUseStartYear.CheckedChanged += new EventHandler(this.OptUseStartYear_CheckedChanged);
        }
        void OptUseStartYear_CheckedChanged(object sender, EventArgs e)
        {
            this.ux_optStartYear.Enabled = this.ux_optUseStartYear.Checked;
        }
        public void SetInitialState(OptimizationSettings optimizationSettings, int minYear, int maxYear)
        {
            this._optimizationSettings = optimizationSettings;
            if      (optimizationSettings.Type == OptimizationType.PassengerAuto) { this.ux_typePassengerAuto.Checked = true; }
            else if (optimizationSettings.Type == OptimizationType.LightTruck   ) { this.ux_typeLightTruck   .Checked = true; }
            else                                                                  { this.ux_typeDefault      .Checked = true; }
            if   (optimizationSettings.Mode == OptimizationMode.ZeroNetBeneftis) { this.ux_modeZeroNetBenefits   .Checked = true; }
            else                                                                 { this.ux_modeMaximumNetBenefits.Checked = true; }
            this.ux_iterationAboveOptimum.Text = optimizationSettings.AboveOptimum.ToString("0"      );
            this.ux_iterationBelowOptimum.Text = optimizationSettings.BelowOptimum.ToString("0"      );
            this.ux_iterationIncrement   .Text = optimizationSettings.Increment   .ToString("0.00000");
            this.ux_optUseStartYear.Checked = (optimizationSettings.StartYear >= minYear);
            this.ux_optStartYear   .Enabled = (optimizationSettings.StartYear >= minYear);
            this.ux_optStartYear   .Text    = (optimizationSettings.StartYear >= minYear) ? optimizationSettings.StartYear.ToString("0") : minYear.ToString("0");
            this.RegisterNumericTextControl(this.ux_optStartYear, minYear, minYear, maxYear,
                "The starting optimization year should be between {MIN} and {MAX}.", true, "0");
            base.SaveChanges();
        }
        public override void SaveChanges()
        {
            if (this.SettingsChanged)
            {   
                this._optimizationSettings.Type = (this.ux_typePassengerAuto.Checked) ? OptimizationType.PassengerAuto :
                    (this.ux_typeLightTruck.Checked) ? OptimizationType.LightTruck : OptimizationType.Default;
                this._optimizationSettings.Mode = (this.ux_modeZeroNetBenefits.Checked) ? OptimizationMode.ZeroNetBeneftis :
                    OptimizationMode.MaximumNetBenefits;
                this._optimizationSettings.AboveOptimum = Interaction.GetInt32 (this.ux_iterationAboveOptimum.Text);
                this._optimizationSettings.BelowOptimum = Interaction.GetInt32 (this.ux_iterationBelowOptimum.Text);
                this._optimizationSettings.Increment    = Interaction.GetDouble(this.ux_iterationIncrement   .Text);
                this._optimizationSettings.StartYear = (this.ux_optUseStartYear.Checked) ? Interaction.GetInt32(this.ux_optStartYear.Text) : 0;
                base.SaveChanges();
            }
        }
        #endregion
        #region 
        #region 
        Label ux_typeLabel;
        Panel ux_typePanel;
        RadioButton ux_typePassengerAuto;
        RadioButton ux_typeLightTruck;
        RadioButton ux_typeDefault;
        Label ux_modeLabel;
        Panel ux_modePanel;
        RadioButton ux_modeMaximumNetBenefits;
        RadioButton ux_modeZeroNetBenefits;
        Label ux_iterationOptionsLabel;
        Panel ux_iterationOptionsPanel;
        TextBox ux_iterationAboveOptimum;
        TextBox ux_iterationBelowOptimum;
        TextBox ux_iterationIncrement;
        Label ux_iterationIncrementLabel;
        Label ux_iterationBelowOptimumLabel;
        Label ux_iterationAboveOptimumLabel;
        CheckBox ux_optUseStartYear;
        TextBox ux_optStartYear;
        #endregion
        OptimizationSettings _optimizationSettings;
        #endregion
    }
}

