using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Volpe.Cafe;
using Volpe.Cafe.Settings;
using Volpe.Cafe.Utils;
namespace Volpe.Cafe.UI.Panels
{
    class RuntimeSettingsPanel : CafeUserControl
    {
        #region 
        public RuntimeSettingsPanel()
        {
            this.InitializeComponent();
            this.PostInitialize();
        }
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }
        #endregion
        #region 
        #region 
        void InitializeComponent()
        {
            this.ux_maxTechMode = new System.Windows.Forms.CheckBox();
            this.ux_overcomply = new System.Windows.Forms.CheckBox();
            this.ux_creditTrading = new System.Windows.Forms.CheckBox();
            this.ux_paramOverrides = new Volpe.Cafe.UI.Panels.ParamOverridesPanel();
            this.ux_mergedFleet = new System.Windows.Forms.CheckBox();
            this.ux_dynamicFleetShare = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            this.ux_maxTechMode.AutoSize = true;
            this.ux_maxTechMode.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_maxTechMode.Location = new System.Drawing.Point(8, 8);
            this.ux_maxTechMode.Name = "ux_maxTechMode";
            this.ux_maxTechMode.Size = new System.Drawing.Size(218, 17);
            this.ux_maxTechMode.TabIndex = 0;
            this.ux_maxTechMode.Text = "Operate in \"Maximum Technology\" mode";
            this.ux_maxTechMode.UseVisualStyleBackColor = true;
            this.ux_overcomply.AutoSize = true;
            this.ux_overcomply.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_overcomply.Location = new System.Drawing.Point(8, 24);
            this.ux_overcomply.Name = "ux_overcomply";
            this.ux_overcomply.Size = new System.Drawing.Size(176, 17);
            this.ux_overcomply.TabIndex = 1;
            this.ux_overcomply.Text = "Allow Voluntary Overcompliance";
            this.ux_overcomply.UseVisualStyleBackColor = true;
            this.ux_creditTrading.AutoSize = true;
            this.ux_creditTrading.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_creditTrading.Location = new System.Drawing.Point(8, 40);
            this.ux_creditTrading.Name = "ux_creditTrading";
            this.ux_creditTrading.Size = new System.Drawing.Size(215, 17);
            this.ux_creditTrading.TabIndex = 2;
            this.ux_creditTrading.Text = "Allow Credit Transfers and Carry Forward";
            this.ux_creditTrading.UseVisualStyleBackColor = true;
            this.ux_paramOverrides.AutoScroll = true;
            this.ux_paramOverrides.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ux_paramOverrides.Location = new System.Drawing.Point(0, 88);
            this.ux_paramOverrides.MinimumSize = new System.Drawing.Size(440, 0);
            this.ux_paramOverrides.Name = "ux_paramOverrides";
            this.ux_paramOverrides.Size = new System.Drawing.Size(440, 192);
            this.ux_paramOverrides.TabIndex = 5;
            this.ux_mergedFleet.AutoSize = true;
            this.ux_mergedFleet.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_mergedFleet.Location = new System.Drawing.Point(8, 72);
            this.ux_mergedFleet.Name = "ux_mergedFleet";
            this.ux_mergedFleet.Size = new System.Drawing.Size(159, 17);
            this.ux_mergedFleet.TabIndex = 4;
            this.ux_mergedFleet.Text = "Merge the Fleet for Modeling";
            this.ux_mergedFleet.UseVisualStyleBackColor = true;
            this.ux_dynamicFleetShare.AutoSize = true;
            this.ux_dynamicFleetShare.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
            this.ux_dynamicFleetShare.Location = new System.Drawing.Point(8, 56);
            this.ux_dynamicFleetShare.Name = "ux_dynamicFleetShare";
            this.ux_dynamicFleetShare.Size = new System.Drawing.Size(208, 17);
            this.ux_dynamicFleetShare.TabIndex = 3;
            this.ux_dynamicFleetShare.Text = "Enable the Dynamic Fleet Share Model";
            this.Controls.Add(this.ux_mergedFleet);
            this.Controls.Add(this.ux_dynamicFleetShare);
            this.Controls.Add(this.ux_paramOverrides);
            this.Controls.Add(this.ux_creditTrading);
            this.Controls.Add(this.ux_overcomply);
            this.Controls.Add(this.ux_maxTechMode);
            this.MinimumSize = new System.Drawing.Size(440, 0);
            this.Name = "RuntimeSettingsPanel";
            this.Size = new System.Drawing.Size(440, 280);
            this.ResumeLayout(false);
            this.PerformLayout();
        }
        #endregion
        void PostInitialize()
        {
            this.AutoInitializeCheckChangesDetector(this.Controls);
        }
        void MaxTechMode_CheckedChanged(object sender, EventArgs e)
        {
            bool enabled = !this.ux_maxTechMode.Checked;
            this.ux_overcomply    .Enabled = enabled;
            this.ux_creditTrading .Enabled = enabled;
            this.ux_paramOverrides.Enabled = enabled;
        }
        public void SetInitialState(ModelingSettings settings)
        {
            this._settings = settings;
            this.ux_maxTechMode      .Checked = settings.OperatingModes       .NoFines;
            this.ux_overcomply       .Checked = settings.OperatingModes       .Overcomply;
            this.ux_creditTrading    .Checked = settings.CreditTradingSettings.AllowTrading;
            this.ux_dynamicFleetShare.Checked = settings.OperatingModes       .DynamicFleetShare;
            this.ux_mergedFleet      .Checked = settings.OperatingModes       .MergedFleet;
            this.ux_paramOverrides.SetInitialState(settings.ParametersOverrides);
            base.SaveChanges();
        }
        public override void SaveChanges()
        {
            if (this.SettingsChanged)
            {
                this._settings.OperatingModes       .NoFines               = this.ux_maxTechMode      .Checked;
                this._settings.OperatingModes       .IgnoreYearAvailable   = this.ux_maxTechMode      .Checked;
                this._settings.OperatingModes       .IgnorePhaseIn         = this.ux_maxTechMode      .Checked;
                this._settings.OperatingModes       .IgnoreRefreshRedesign = this.ux_maxTechMode      .Checked;
                this._settings.OperatingModes       .Overcomply            = this.ux_overcomply       .Checked;
                this._settings.CreditTradingSettings.AllowTrading          = this.ux_creditTrading    .Checked;
                this._settings.OperatingModes       .DynamicFleetShare     = this.ux_dynamicFleetShare.Checked;
                this._settings.OperatingModes       .MergedFleet           = this.ux_mergedFleet      .Checked;
                this.ux_paramOverrides.SaveChanges();
                base.SaveChanges();
            }
        }
        #endregion
        #region 
        [Browsable(false)]
        public override bool SettingsChanged { get { return this.ux_paramOverrides.SettingsChanged || base.SettingsChanged; } }
        #endregion
        #region 
        #region 
        CheckBox ux_maxTechMode;
        CheckBox ux_overcomply;
        CheckBox ux_creditTrading;
        CheckBox ux_dynamicFleetShare;
        CheckBox ux_mergedFleet;
        ParamOverridesPanel ux_paramOverrides;
        #endregion
        ModelingSettings _settings;
        #endregion
    }
}

