using System;
namespace Volpe.Cafe.Data
{
    [Serializable]
    public struct M6Double
    {
        #region 
        static M6Double()
        {
            M6Double.Zero = new M6Double(0);
            M6Double.Zero = new M6Double(1);
        }
        M6Double(double value)
            : this(value, value, value, value, value,
                   value, value, value, value, value,
                   value, value, value, value, value,
                   value, value, value, value, value)
        {
        }
        M6Double(
            double ldvGas , double ldvDsl , double ldvE85 , double ldvElc, double ldvHgn,
            double ldt1Gas, double ldt1Dsl, double ldt1E85, double ldt1Elc, double ldt1Hgn,
            double ldt2Gas, double ldt2Dsl, double ldt2E85, double ldt2Elc, double ldt2Hgn,
            double hdvGas , double hdvDsl , double hdvE85 , double hdvElc, double hdvHgn)
        {
            this.LDV_Gas  = ldvGas ; this.LDV_Dsl  = ldvDsl ; this.LDV_E85  = ldvE85 ; this.LDV_Elc  = ldvElc ; this.LDV_Hgn  = ldvHgn;
            this.LDT1_Gas = ldt1Gas; this.LDT1_Dsl = ldt1Dsl; this.LDT1_E85 = ldt1E85; this.LDT1_Elc = ldt1Elc; this.LDT1_Hgn = ldt1Hgn;
            this.LDT2_Gas = ldt2Gas; this.LDT2_Dsl = ldt2Dsl; this.LDT2_E85 = ldt2E85; this.LDT2_Elc = ldt2Elc; this.LDT2_Hgn = ldt2Hgn;
            this.HDV_Gas  = hdvGas ; this.HDV_Dsl  = hdvDsl ; this.HDV_E85  = hdvE85 ; this.HDV_Elc  = hdvElc ; this.HDV_Hgn  = hdvHgn;
        }
        #endregion
        #region 
        #region 
        public static M6Double operator +(M6Double value1, M6Double value2)
        {
            return new M6Double(
                value1.LDV_Gas  + value2.LDV_Gas , value1.LDV_Dsl  + value2.LDV_Dsl , value1.LDV_E85  + value2.LDV_E85 , value1.LDV_Elc  + value2.LDV_Elc , value1.LDV_Hgn  + value2.LDV_Hgn ,
                value1.LDT1_Gas + value2.LDT1_Gas, value1.LDT1_Dsl + value2.LDT1_Dsl, value1.LDT1_E85 + value2.LDT1_E85, value1.LDT1_Elc + value2.LDT1_Elc, value1.LDT1_Hgn + value2.LDT1_Hgn,
                value1.LDT2_Gas + value2.LDT2_Gas, value1.LDT2_Dsl + value2.LDT2_Dsl, value1.LDT2_E85 + value2.LDT2_E85, value1.LDT2_Elc + value2.LDT2_Elc, value1.LDT2_Hgn + value2.LDT2_Hgn,
                value1.HDV_Gas  + value2.HDV_Gas , value1.HDV_Dsl  + value2.HDV_Dsl , value1.HDV_E85  + value2.HDV_E85 , value1.HDV_Elc  + value2.HDV_Elc , value1.HDV_Hgn  + value2.HDV_Hgn);
        }
        public static M6Double operator +(M6Double value1, double value2)
        {
            return value1 + new M6Double(value2);
        }
        public static M6Double operator +(double value1, M6Double value2)
        {
            return new M6Double(value1) + value2;
        }
        public static M6Double operator +(M6Double value1, int value2)
        {
            return value1 + new M6Double(value2);
        }
        public static M6Double operator +(int value1, M6Double value2)
        {
            return new M6Double(value1) + value2;
        }
        public static M6Double operator -(M6Double value1, M6Double value2)
        {
            return new M6Double(
                value1.LDV_Gas  - value2.LDV_Gas , value1.LDV_Dsl  - value2.LDV_Dsl , value1.LDV_E85  - value2.LDV_E85 , value1.LDV_Elc  - value2.LDV_Elc , value1.LDV_Hgn  - value2.LDV_Hgn ,
                value1.LDT1_Gas - value2.LDT1_Gas, value1.LDT1_Dsl - value2.LDT1_Dsl, value1.LDT1_E85 - value2.LDT1_E85, value1.LDT1_Elc - value2.LDT1_Elc, value1.LDT1_Hgn - value2.LDT1_Hgn,
                value1.LDT2_Gas - value2.LDT2_Gas, value1.LDT2_Dsl - value2.LDT2_Dsl, value1.LDT2_E85 - value2.LDT2_E85, value1.LDT2_Elc - value2.LDT2_Elc, value1.LDT2_Hgn - value2.LDT2_Hgn,
                value1.HDV_Gas  - value2.HDV_Gas , value1.HDV_Dsl  - value2.HDV_Dsl , value1.HDV_E85  - value2.HDV_E85 , value1.HDV_Elc  - value2.HDV_Elc , value1.HDV_Hgn  - value2.HDV_Hgn);
        }
        public static M6Double operator -(M6Double value1, double value2)
        {
            return value1 - new M6Double(value2);
        }
        public static M6Double operator -(double value1, M6Double value2)
        {
            return new M6Double(value1) - value2;
        }
        public static M6Double operator -(M6Double value1, int value2)
        {
            return value1 - new M6Double(value2);
        }
        public static M6Double operator -(int value1, M6Double value2)
        {
            return new M6Double(value1) - value2;
        }
        public static M6Double operator *(M6Double value1, M6Double value2)
        {
            return new M6Double(
                value1.LDV_Gas  * value2.LDV_Gas , value1.LDV_Dsl  * value2.LDV_Dsl , value1.LDV_E85  * value2.LDV_E85 , value1.LDV_Elc  * value2.LDV_Elc , value1.LDV_Hgn  * value2.LDV_Hgn ,
                value1.LDT1_Gas * value2.LDT1_Gas, value1.LDT1_Dsl * value2.LDT1_Dsl, value1.LDT1_E85 * value2.LDT1_E85, value1.LDT1_Elc * value2.LDT1_Elc, value1.LDT1_Hgn * value2.LDT1_Hgn,
                value1.LDT2_Gas * value2.LDT2_Gas, value1.LDT2_Dsl * value2.LDT2_Dsl, value1.LDT2_E85 * value2.LDT2_E85, value1.LDT2_Elc * value2.LDT2_Elc, value1.LDT2_Hgn * value2.LDT2_Hgn,
                value1.HDV_Gas  * value2.HDV_Gas , value1.HDV_Dsl  * value2.HDV_Dsl , value1.HDV_E85  * value2.HDV_E85 , value1.HDV_Elc  * value2.HDV_Elc , value1.HDV_Hgn  * value2.HDV_Hgn);
        }
        public static M6Double operator *(M6Double value1, double value2)
        {
            return value1 * new M6Double(value2);
        }
        public static M6Double operator *(double value1, M6Double value2)
        {
            return new M6Double(value1) * value2;
        }
        public static M6Double operator *(M6Double value1, int value2)
        {
            return value1 * new M6Double(value2);
        }
        public static M6Double operator *(int value1, M6Double value2)
        {
            return new M6Double(value1) * value2;
        }
        public static M6Double operator /(M6Double value1, M6Double value2)
        {
            return new M6Double(
                value1.LDV_Gas  / value2.LDV_Gas , value1.LDV_Dsl  / value2.LDV_Dsl , value1.LDV_E85  / value2.LDV_E85 , value1.LDV_Elc  / value2.LDV_Elc , value1.LDV_Hgn  / value2.LDV_Hgn ,
                value1.LDT1_Gas / value2.LDT1_Gas, value1.LDT1_Dsl / value2.LDT1_Dsl, value1.LDT1_E85 / value2.LDT1_E85, value1.LDT1_Elc / value2.LDT1_Elc, value1.LDT1_Hgn / value2.LDT1_Hgn,
                value1.LDT2_Gas / value2.LDT2_Gas, value1.LDT2_Dsl / value2.LDT2_Dsl, value1.LDT2_E85 / value2.LDT2_E85, value1.LDT2_Elc / value2.LDT2_Elc, value1.LDT2_Hgn / value2.LDT2_Hgn,
                value1.HDV_Gas  / value2.HDV_Gas , value1.HDV_Dsl  / value2.HDV_Dsl , value1.HDV_E85  / value2.HDV_E85 , value1.HDV_Elc  / value2.HDV_Elc , value1.HDV_Hgn  / value2.HDV_Hgn);
        }
        public static M6Double operator /(M6Double value1, double value2)
        {
            return value1 / new M6Double(value2);
        }
        public static M6Double operator /(double value1, M6Double value2)
        {
            return new M6Double(value1) / value2;
        }
        public static M6Double operator /(M6Double value1, int value2)
        {
            return value1 / new M6Double(value2);
        }
        public static M6Double operator /(int value1, M6Double value2)
        {
            return new M6Double(value1) / value2;
        }
        public static M6Double operator +(M6Double value)
        {
            return M6Double.Zero + value;
        }
        public static M6Double operator -(M6Double value)
        {
            return M6Double.Zero - value;
        }
        public static M6Double operator ++(M6Double value)
        {
            return value + M6Double.One;
        }
        public static M6Double operator --(M6Double value)
        {
            return value - M6Double.One;
        }
        public static bool operator ==(M6Double value1, M6Double value2)
        {
            return value1.Equals(value2);
        }
        public static bool operator !=(M6Double value1, M6Double value2)
        {
            return !value1.Equals(value2);
        }
        #endregion
        public override string ToString()
        {
            return "{" +
                "Gasoline="    + this.Gasoline   .ToString() +
                " (LDV="       + this.LDV_Gas    .ToString() +
                ", LT1="       + this.LDT1_Gas   .ToString() +
                ", LT2="       + this.LDT2_Gas   .ToString() +
                ", HDV="       + this.HDV_Gas    .ToString() + "), " +
                "Diesel="      + this.Diesel     .ToString() +
                " (LDV="       + this.LDV_Dsl    .ToString() +
                ", LT1="       + this.LDT1_Dsl   .ToString() +
                ", LT2="       + this.LDT2_Dsl   .ToString() +
                ", HDV="       + this.HDV_Dsl    .ToString() + "), " +
                "Ethanol85="   + this.Ethanol85  .ToString() +
                " (LDV="       + this.LDV_E85    .ToString() +
                ", LT1="       + this.LDT1_E85   .ToString() +
                ", LT2="       + this.LDT2_E85   .ToString() +
                ", HDV="       + this.HDV_E85    .ToString() + "), " +
                "Electricity=" + this.Electricity.ToString() +
                " (LDV="       + this.LDV_Elc    .ToString() +
                ", LT1="       + this.LDT1_Elc   .ToString() +
                ", LT2="       + this.LDT2_Elc   .ToString() +
                ", HDV="       + this.HDV_Elc    .ToString() + "), " +
                "Hydrogen="    + this.Hydrogen   .ToString() +
                " (LDV="       + this.LDV_Hgn    .ToString() +
                ", LT1="       + this.LDT1_Hgn   .ToString() +
                ", LT2="       + this.LDT2_Hgn   .ToString() +
                ", HDV="       + this.HDV_Hgn    .ToString() + "), " +
                "Total="       + this.Total      .ToString() + "}";
        }
        public override int GetHashCode()
        {
            return (
                this.LDV_Gas .GetHashCode() ^ this.LDV_Dsl .GetHashCode() ^ this.LDV_E85 .GetHashCode() ^ this.LDV_Elc .GetHashCode() ^ this.LDV_Hgn .GetHashCode() ^
                this.LDT1_Gas.GetHashCode() ^ this.LDT1_Dsl.GetHashCode() ^ this.LDT1_E85.GetHashCode() ^ this.LDT1_Elc.GetHashCode() ^ this.LDT1_Hgn.GetHashCode() ^
                this.LDT2_Gas.GetHashCode() ^ this.LDT2_Dsl.GetHashCode() ^ this.LDT2_E85.GetHashCode() ^ this.LDT2_Elc.GetHashCode() ^ this.LDT2_Hgn.GetHashCode() ^
                this.HDV_Gas .GetHashCode() ^ this.HDV_Dsl .GetHashCode() ^ this.HDV_E85 .GetHashCode() ^ this.HDV_Elc .GetHashCode() ^ this.HDV_Hgn .GetHashCode());
        }
        public override bool Equals(object obj)
        {
            if (obj is M6Double) { return this.Equals((M6Double)obj); }
            else                 { return base.Equals(obj); }
        }
        public bool Equals(M6Double value)
        {
            return (
                this.LDV_Gas  == value.LDV_Gas  && this.LDV_Dsl  == value.LDV_Dsl  && this.LDV_E85  == value.LDV_E85  && this.LDV_Elc  == value.LDV_Elc  && this.LDV_Hgn  == value.LDV_Hgn  &&
                this.LDT1_Gas == value.LDT1_Gas && this.LDT1_Dsl == value.LDT1_Dsl && this.LDT1_E85 == value.LDT1_E85 && this.LDT1_Elc == value.LDT1_Elc && this.LDT1_Hgn == value.LDT1_Hgn &&
                this.LDT2_Gas == value.LDT2_Gas && this.LDT2_Dsl == value.LDT2_Dsl && this.LDT2_E85 == value.LDT2_E85 && this.LDT2_Elc == value.LDT2_Elc && this.LDT2_Hgn == value.LDT2_Hgn &&
                this.HDV_Gas  == value.HDV_Gas  && this.HDV_Dsl  == value.HDV_Dsl  && this.HDV_E85  == value.HDV_E85  && this.HDV_Elc  == value.HDV_Elc  && this.HDV_Hgn  == value.HDV_Hgn);
        }
        public double Value(Mobile6Class mobile6Class, FuelType fuelType)
        {
            if (fuelType == FuelType.Gasoline)
            {
                return
                    (mobile6Class == Mobile6Class.LDV ) ? this.LDV_Gas :
                    (mobile6Class == Mobile6Class.LDT1) ? this.LDT1_Gas :
                    (mobile6Class == Mobile6Class.LDT2) ? this.LDT2_Gas :
                    (mobile6Class == Mobile6Class.HDV ) ? this.HDV_Gas : 0;
            }
            else if (fuelType == FuelType.Diesel)
            {
                return
                    (mobile6Class == Mobile6Class.LDV ) ? this.LDV_Dsl :
                    (mobile6Class == Mobile6Class.LDT1) ? this.LDT1_Dsl :
                    (mobile6Class == Mobile6Class.LDT2) ? this.LDT2_Dsl :
                    (mobile6Class == Mobile6Class.HDV ) ? this.HDV_Dsl : 0;
            }
            else if (fuelType == FuelType.Ethanol85)
            {
                return
                    (mobile6Class == Mobile6Class.LDV ) ? this.LDV_E85 :
                    (mobile6Class == Mobile6Class.LDT1) ? this.LDT1_E85 :
                    (mobile6Class == Mobile6Class.LDT2) ? this.LDT2_E85 :
                    (mobile6Class == Mobile6Class.HDV ) ? this.HDV_E85 : 0;
            }
            else if (fuelType == FuelType.Electricity)
            {
                return
                    (mobile6Class == Mobile6Class.LDV ) ? this.LDV_Elc :
                    (mobile6Class == Mobile6Class.LDT1) ? this.LDT1_Elc :
                    (mobile6Class == Mobile6Class.LDT2) ? this.LDT2_Elc :
                    (mobile6Class == Mobile6Class.HDV ) ? this.HDV_Elc : 0;
            }
            else if (fuelType == FuelType.Hydrogen)
            {
                return
                    (mobile6Class == Mobile6Class.LDV ) ? this.LDV_Hgn :
                    (mobile6Class == Mobile6Class.LDT1) ? this.LDT1_Hgn :
                    (mobile6Class == Mobile6Class.LDT2) ? this.LDT2_Hgn :
                    (mobile6Class == Mobile6Class.HDV ) ? this.HDV_Hgn : 0;
            }
            else
            {
                return 0;
            }
        }
        public void ZeroNaNs()
        {
            if (double.IsNaN(this.LDV_Gas )) { this.LDV_Gas  = 0.0; }
            if (double.IsNaN(this.LDV_Dsl )) { this.LDV_Dsl  = 0.0; }
            if (double.IsNaN(this.LDV_E85 )) { this.LDV_E85  = 0.0; }
            if (double.IsNaN(this.LDV_Elc )) { this.LDV_Elc  = 0.0; }
            if (double.IsNaN(this.LDV_Hgn )) { this.LDV_Hgn  = 0.0; }
            if (double.IsNaN(this.LDT1_Gas)) { this.LDT1_Gas = 0.0; }
            if (double.IsNaN(this.LDT1_Dsl)) { this.LDT1_Dsl = 0.0; }
            if (double.IsNaN(this.LDT1_E85)) { this.LDT1_E85 = 0.0; }
            if (double.IsNaN(this.LDT1_Elc)) { this.LDT1_Elc = 0.0; }
            if (double.IsNaN(this.LDT1_Hgn)) { this.LDT1_Hgn = 0.0; }
            if (double.IsNaN(this.LDT2_Gas)) { this.LDT2_Gas = 0.0; }
            if (double.IsNaN(this.LDT2_Dsl)) { this.LDT2_Dsl = 0.0; }
            if (double.IsNaN(this.LDT2_E85)) { this.LDT2_E85 = 0.0; }
            if (double.IsNaN(this.LDT2_Elc)) { this.LDT2_Elc = 0.0; }
            if (double.IsNaN(this.LDT2_Hgn)) { this.LDT2_Hgn = 0.0; }
            if (double.IsNaN(this.HDV_Gas )) { this.HDV_Gas  = 0.0; }
            if (double.IsNaN(this.HDV_Dsl )) { this.HDV_Dsl  = 0.0; }
            if (double.IsNaN(this.HDV_E85 )) { this.HDV_E85  = 0.0; }
            if (double.IsNaN(this.HDV_Elc )) { this.HDV_Elc  = 0.0; }
            if (double.IsNaN(this.HDV_Hgn )) { this.HDV_Hgn  = 0.0; }
        }
        public void Clear()
        {
            this.LDV_Gas  = this.LDV_Dsl  = this.LDV_E85  = this.LDV_Elc  = this.LDV_Hgn  = 0;
            this.LDT1_Gas = this.LDT1_Dsl = this.LDT1_E85 = this.LDT1_Elc = this.LDT1_Hgn = 0;
            this.LDT2_Gas = this.LDT2_Dsl = this.LDT2_E85 = this.LDT2_Elc = this.LDT2_Hgn = 0;
            this.HDV_Gas  = this.HDV_Dsl  = this.HDV_E85  = this.HDV_Elc  = this.HDV_Hgn  = 0;
        }
        #endregion
        #region 
        public double this[Mobile6Class mobile6Class, FuelType fuelType]
        {
            get { return this.Value(mobile6Class, fuelType); }
            set
            {
                if (fuelType == FuelType.Gasoline)
                {
                    if      (mobile6Class == Mobile6Class.LDV ) { this.LDV_Gas  = value; }
                    else if (mobile6Class == Mobile6Class.LDT1) { this.LDT1_Gas = value; }
                    else if (mobile6Class == Mobile6Class.LDT2) { this.LDT2_Gas = value; }
                    else if (mobile6Class == Mobile6Class.HDV ) { this.HDV_Gas  = value; }
                }
                else if (fuelType == FuelType.Diesel)
                {
                    if      (mobile6Class == Mobile6Class.LDV ) { this.LDV_Dsl  = value; }
                    else if (mobile6Class == Mobile6Class.LDT1) { this.LDT1_Dsl = value; }
                    else if (mobile6Class == Mobile6Class.LDT2) { this.LDT2_Dsl = value; }
                    else if (mobile6Class == Mobile6Class.HDV ) { this.HDV_Dsl  = value; }
                }
                else if (fuelType == FuelType.Ethanol85)
                {
                    if      (mobile6Class == Mobile6Class.LDV ) { this.LDV_E85  = value; }
                    else if (mobile6Class == Mobile6Class.LDT1) { this.LDT1_E85 = value; }
                    else if (mobile6Class == Mobile6Class.LDT2) { this.LDT2_E85 = value; }
                    else if (mobile6Class == Mobile6Class.HDV ) { this.HDV_E85  = value; }
                }
                else if (fuelType == FuelType.Electricity)
                {
                    if      (mobile6Class == Mobile6Class.LDV ) { this.LDV_Elc  = value; }
                    else if (mobile6Class == Mobile6Class.LDT1) { this.LDT1_Elc = value; }
                    else if (mobile6Class == Mobile6Class.LDT2) { this.LDT2_Elc = value; }
                    else if (mobile6Class == Mobile6Class.HDV ) { this.HDV_Elc  = value; }
                }
                else if (fuelType == FuelType.Hydrogen)
                {
                    if      (mobile6Class == Mobile6Class.LDV ) { this.LDV_Hgn  = value; }
                    else if (mobile6Class == Mobile6Class.LDT1) { this.LDT1_Hgn = value; }
                    else if (mobile6Class == Mobile6Class.LDT2) { this.LDT2_Hgn = value; }
                    else if (mobile6Class == Mobile6Class.HDV ) { this.HDV_Hgn  = value; }
                }
            }
        }
        public double Gasoline
        {
            get
            {
                if (double.IsNaN(this.LDV_Gas) && double.IsNaN(this.LDT1_Gas) && double.IsNaN(this.LDT2_Gas) && double.IsNaN(this.HDV_Gas))
                {
                    return double.NaN;
                }
                else
                {
                    return (double.IsNaN(this.LDV_Gas ) ? 0 : this.LDV_Gas ) +
                           (double.IsNaN(this.LDT1_Gas) ? 0 : this.LDT1_Gas) +
                           (double.IsNaN(this.LDT2_Gas) ? 0 : this.LDT2_Gas) +
                           (double.IsNaN(this.HDV_Gas ) ? 0 : this.HDV_Gas );
                }
            }
        }
        public double Diesel
        {
            get
            {
                if (double.IsNaN(this.LDV_Dsl) && double.IsNaN(this.LDT1_Dsl) && double.IsNaN(this.LDT2_Dsl) && double.IsNaN(this.HDV_Dsl))
                {
                    return double.NaN;
                }
                else
                {
                    return (double.IsNaN(this.LDV_Dsl ) ? 0 : this.LDV_Dsl ) +
                           (double.IsNaN(this.LDT1_Dsl) ? 0 : this.LDT1_Dsl) +
                           (double.IsNaN(this.LDT2_Dsl) ? 0 : this.LDT2_Dsl) +
                           (double.IsNaN(this.HDV_Dsl ) ? 0 : this.HDV_Dsl );
                }
            }
        }
        public double Ethanol85
        {
            get
            {
                if (double.IsNaN(this.LDV_E85) && double.IsNaN(this.LDT1_E85) && double.IsNaN(this.LDT2_E85) && double.IsNaN(this.HDV_E85))
                {
                    return double.NaN;
                }
                else
                {
                    return (double.IsNaN(this.LDV_E85 ) ? 0 : this.LDV_E85 ) +
                           (double.IsNaN(this.LDT1_E85) ? 0 : this.LDT1_E85) +
                           (double.IsNaN(this.LDT2_E85) ? 0 : this.LDT2_E85) +
                           (double.IsNaN(this.HDV_E85 ) ? 0 : this.HDV_E85 );
                }
            }
        }
        public double Electricity
        {
            get
            {
                if (double.IsNaN(this.LDV_Elc) && double.IsNaN(this.LDT1_Elc) && double.IsNaN(this.LDT2_Elc) && double.IsNaN(this.HDV_Elc))
                {
                    return double.NaN;
                }
                else
                {
                    return (double.IsNaN(this.LDV_Elc ) ? 0 : this.LDV_Elc ) +
                           (double.IsNaN(this.LDT1_Elc) ? 0 : this.LDT1_Elc) +
                           (double.IsNaN(this.LDT2_Elc) ? 0 : this.LDT2_Elc) +
                           (double.IsNaN(this.HDV_Elc ) ? 0 : this.HDV_Elc );
                }
            }
        }
        public double Hydrogen
        {
            get
            {
                if (double.IsNaN(this.LDV_Hgn) && double.IsNaN(this.LDT1_Hgn) && double.IsNaN(this.LDT2_Hgn) && double.IsNaN(this.HDV_Hgn))
                {
                    return double.NaN;
                }
                else
                {
                    return (double.IsNaN(this.LDV_Hgn ) ? 0 : this.LDV_Hgn ) +
                           (double.IsNaN(this.LDT1_Hgn) ? 0 : this.LDT1_Hgn) +
                           (double.IsNaN(this.LDT2_Hgn) ? 0 : this.LDT2_Hgn) +
                           (double.IsNaN(this.HDV_Hgn ) ? 0 : this.HDV_Hgn );
                }
            }
        }
        public double Total
        {
            get
            {
                double gas = this.Gasoline, dsl = this.Diesel, e85 = this.Ethanol85, elc = this.Electricity, hgn = this.Hydrogen;
                if (double.IsNaN(gas) && double.IsNaN(dsl) && double.IsNaN(e85) && double.IsNaN(elc) && double.IsNaN(hgn))
                {
                    return double.NaN;
                }
                else
                {
                    return (double.IsNaN(gas) ? 0 : gas) + (double.IsNaN(dsl) ? 0 : dsl) + (double.IsNaN(e85) ? 0 : e85) +
                           (double.IsNaN(elc) ? 0 : elc) + (double.IsNaN(hgn) ? 0 : hgn);
                }
            }
        }
        #endregion
        #region 
        public static readonly M6Double Zero;
        public static readonly M6Double One;
        public double LDV_Gas;
        public double LDV_Dsl;
        public double LDV_E85;
        public double LDV_Elc;
        public double LDV_Hgn;
        public double LDT1_Gas;
        public double LDT1_Dsl;
        public double LDT1_E85;
        public double LDT1_Elc;
        public double LDT1_Hgn;
        public double LDT2_Gas;
        public double LDT2_Dsl;
        public double LDT2_E85;
        public double LDT2_Elc;
        public double LDT2_Hgn;
        public double HDV_Gas;
        public double HDV_Dsl;
        public double HDV_E85;
        public double HDV_Elc;
        public double HDV_Hgn;
        #endregion
    }
}

