using System;
using System.Collections.Generic;
using Volpe.Cafe;
using Volpe.Cafe.Utils;
using RC = Volpe.Cafe.RegulatoryClass;
namespace Volpe.Cafe.Data
{
    [Serializable]
    public sealed class Vehicle
    {
        #region 
        [Serializable]
        public sealed class CDescription
        {
            #region 
            internal CDescription(double baseWeight)
            {
                this.BaseWeight = baseWeight;
            }
            #endregion
            #region 
            internal CDescription Clone()
            {
                Vehicle.CDescription vd = new Vehicle.CDescription(this.BaseWeight);
                vd.Code                = this.Code;
                vd.Manufacturer        = this.Manufacturer;
                vd.Model               = this.Model;
                vd.Nameplate           = this.Nameplate;
                vd.EngineCode          = this.EngineCode;
                vd.TransmissionCode    = this.TransmissionCode;
                vd.Origin              = this.Origin;
                vd.FuelEconomy         = this.FuelEconomy;
                vd.FuelEconomy2        = this.FuelEconomy2;
                vd.FuelShare           = this.FuelShare;
                vd.Sales               = (double[])Interaction.CloneArray(this.Sales, typeof(double));
                vd.Msrp                = (double[])Interaction.CloneArray(this.Msrp , typeof(double));
                vd.Price               = (double[])Interaction.CloneArray(this.Price, typeof(double));
                vd.RegulatoryIndicator = this.RegulatoryIndicator;
                vd.TechnologyClass     = this.TechnologyClass;
                vd.SafetyClass         = this.SafetyClass;
                vd.MarketSegment       = this.MarketSegment;
                vd.SmallCar            = this.SmallCar;
                vd.MLCar               = this.MLCar;
                vd.Truck               = this.Truck;
                vd.Van                 = this.Van;
                vd.SUV                 = this.SUV;
                vd.AWD                 = this.AWD;
                vd.Prestige            = this.Prestige;
                vd.MM                  = this.MM;
                vd.ASC1                = this.ASC1;
                vd.ASC2                = this.ASC2;
                vd.Class               = this.Class;
                vd.Style               = this.Style;
                vd.Structure           = this.Structure;
                vd.Drive               = this.Drive;
                vd.Wheelbase           = this.Wheelbase;
                vd.Footprint           = this.Footprint;
                vd.CurbWeight          = this.CurbWeight;
                vd.GVWR                = this.GVWR;
                vd.Seating             = this.Seating;
                vd.FuelCapacity        = this.FuelCapacity;
                vd.HybridType          = this.HybridType;
                vd.ElectricPower       = this.ElectricPower;
                vd.ElectricRange       = this.ElectricRange;
                vd.RefreshYears        = (int[])Interaction.CloneArray(this.RefreshYears , typeof(int));
                vd.RedesignYears       = (int[])Interaction.CloneArray(this.RedesignYears, typeof(int));
                vd.Percent2Dr          = this.Percent2Dr;
                vd.EmploymentHours     = this.EmploymentHours;
                vd.UsedTechnologies      = (int[])Interaction.CloneArray(this.UsedTechnologies     , typeof(int));
                vd.AvailableTechnologies = (int[])Interaction.CloneArray(this.AvailableTechnologies, typeof(int));
                return vd;
            }
            public override string ToString()
            {
                return (this.Model + "(Eng: " + this.EngineCode + ", Trn: " + this.TransmissionCode + ")");
            }
            #endregion
            #region 
            public int Code;
            public string Manufacturer;
            public string Model;
            public string Nameplate;
            public int EngineCode;
            public int TransmissionCode;
            public char Origin;
            public FuelValue FuelEconomy;
            public FuelValue FuelEconomy2;
            public FuelValue FuelShare;
            public double[] Sales;
            public double[] Msrp;
            public double[] Price;
            public string RegulatoryIndicator;
            public string TechnologyClass;
            public string SafetyClass;
            public int MarketSegment;
            public int SmallCar;
            public int MLCar;
            public int Truck;
            public int Van;
            public int SUV;
            public int AWD;
            public int Prestige;
            public double MM;
            public double ASC1;
            public double ASC2;
            public string Class;
            public string Style;
            public string Structure;
            public char Drive;
            public double Wheelbase;
            public double Footprint;
            readonly public double BaseWeight;
            public double CurbWeight;
            public double GVWR;
            public int Seating;
            public double FuelCapacity;
            public string HybridType;
            public double ElectricPower;
            public double ElectricRange;
            public int[] RefreshYears;
            public int[] RedesignYears;
            public double Percent2Dr;
            public double EmploymentHours;
            public int[] UsedTechnologies;
            public int[] AvailableTechnologies;
            #endregion
        }
        [Serializable]
        public sealed class CModelData
        {
            #region 
            internal CModelData() { }
            #endregion
            #region 
            internal Vehicle.CModelData Clone()
            {
                Vehicle.CModelData cv = new Vehicle.CModelData();
                cv.TechCost              = this.TechCost;
                cv.RegCost               = this.RegCost;
                cv.LossOfValue           = this.LossOfValue;
                cv.RelativeLossOfValue   = this.RelativeLossOfValue;
                cv.MaintenanceCost       = this.MaintenanceCost;
                cv.RepairCost            = this.RepairCost;
                cv.TaxesAndFees          = this.TaxesAndFees;
                cv.FinancingCost         = this.FinancingCost;
                cv.InsuranceCost         = this.InsuranceCost;
                cv.TaxCredit             = this.TaxCredit;
                cv.OffCycleCredit        = this.OffCycleCredit;
                cv.SalesOverFE           = this.SalesOverFE;
                cv.TechAvailable         = (bool  [])Interaction.CloneArray(this.TechAvailable        , typeof(bool));
                cv.TechEnabled           = (bool  [])Interaction.CloneArray(this.TechEnabled          , typeof(bool));
                cv.TechUsed              = (bool  [])Interaction.CloneArray(this.TechUsed             , typeof(bool));
                cv.TechApplied           = (bool  [])Interaction.CloneArray(this.TechApplied          , typeof(bool));
                cv.TechAppliedYear       = (int   [])Interaction.CloneArray(this.TechAppliedYear      , typeof(int ));
                cv.TechSuperseded        = (bool  [])Interaction.CloneArray(this.TechSuperseded       , typeof(bool));
                cv.TechSupersededYear    = (int   [])Interaction.CloneArray(this.TechSupersededYear   , typeof(int ));
                cv.TechBackfilled        = (bool  [])Interaction.CloneArray(this.TechBackfilled       , typeof(bool));
                cv.TechPhaseInBackfilled = (bool  [])Interaction.CloneArray(this.TechPhaseInBackfilled, typeof(bool));
                cv.TechIgnored           = (bool  [])Interaction.CloneArray(this.TechIgnored          , typeof(bool));
                cv.TechLingering         = (bool  [])Interaction.CloneArray(this.TechLingering        , typeof(bool));
                if (this.TechLingerYear != null) { cv.TechLingerYear = new ModelYear(this.TechLingerYear.Year); }
                cv.HHUtilities           = (double[])Interaction.CloneArray(this.HHUtilities          , typeof(double));
                cv.HHUtilitiesExp        = (double[])Interaction.CloneArray(this.HHUtilitiesExp       , typeof(double));
                cv.HHProbabilities       = (double[])Interaction.CloneArray(this.HHProbabilities      , typeof(double));
                cv.HHSales               = (double[])Interaction.CloneArray(this.HHSales              , typeof(double));
                return cv;
            }
            #endregion
            #region 
            public double TechCost;
            public double RegCost;
            public double LossOfValue;
            public double RelativeLossOfValue;
            public double MaintenanceCost;
            public double RepairCost;
            public double TaxesAndFees;
            public double FinancingCost;
            public double InsuranceCost;
            public double TaxCredit;
            public double OffCycleCredit;
            public double SalesOverFE;
            public bool[] TechAvailable;
            public bool[] TechEnabled;
            public bool[] TechUsed;
            public bool[] TechApplied;
            public int[] TechAppliedYear;
            public bool[] TechSuperseded;
            public int[] TechSupersededYear;
            public bool[] TechBackfilled;
            public bool[] TechPhaseInBackfilled;
            public bool[] TechIgnored;
            public bool[] TechLingering;
            public ModelYear TechLingerYear;
            public double[] HHUtilities;
            public double[] HHUtilitiesExp;
            public double[] HHProbabilities;
            public double[] HHSales;
            #endregion
        }
        #endregion
        #region 
        Vehicle()
        {
            this._description  = null;
            this._modelData    = null;
            this._manufacturer = null;
            this._engine       = null;
            this._transmission = null;
            this._namePlate    = null;
            this._legacyEng    = null;
            this._legacyTrn    = null;
            this._regClass     = RegulatoryClass.Unregulated;
            this._techClass    = TechnologyClass.None;
            this._mobile6Class = Mobile6Class   .None;
            this._safetyClass  = SafetyClass    .None;
            this._vehicleType  = VehicleType    .None;
            this._hevType      = HEVType        .None;
            this._validYears = null;
        }
        internal Vehicle(Vehicle.CDescription description) : this()
        {
            this._description = description;
            this._modelData = new Vehicle.CModelData();
        }
        #endregion
        #region 
        internal Vehicle Clone()
        {
            Vehicle veh = new Vehicle();
            veh._description  = this._description.Clone();
            veh._modelData    = this._modelData  .Clone();
            veh._manufacturer = this._manufacturer;
            veh._engine       = this._engine;
            veh._transmission = this._transmission;
            veh._namePlate    = this._namePlate;
            if (this._legacyEng != null) { veh._legacyEng = this._legacyEng.Clone(); }
            if (this._legacyTrn != null) { veh._legacyTrn = this._legacyTrn.Clone(); }
            veh._vehicleStyle = this._vehicleStyle;
            veh._vehicleType  = this._vehicleType;
            veh._regClass     = this._regClass;
            veh._techClass    = this._techClass;
            veh._mobile6Class = this._mobile6Class;
            veh._safetyClass  = this._safetyClass;
            veh._hevType      = this._hevType;
            if (this._validYears != null)
            {
                veh._validYears = new ModelYear[this._validYears.Length];
                for (int i = 0; i < this._validYears.Length; i++)
                {
                    veh._validYears[i] = new ModelYear(this._validYears[i].Year);
                }
            }
            return veh;
        }
        internal void Initialize(Manufacturer manufacturer, Vehicle[] vehicles)
        {
            this._manufacturer = manufacturer;
            this._engine       = null;
            this._transmission = null;
            Engine      [] engs = manufacturer.Engines      .ToArray();
            Transmission[] trns = manufacturer.Transmissions.ToArray();
            if (this._description.EngineCode > 0)
            {
                for (int i = 0; i < engs.Length; i++)
                {
                    if (engs[i].Description.Code == this._description.EngineCode)
                    {   
                        this._engine = engs[i];
                        this._engine.Vehicles.Add(this);
                        break;
                    }
                }
            }
            if (this._description.TransmissionCode > 0)
            {
                for (int i = 0; i < trns.Length; i++)
                {
                    if (trns[i].Description.Code == this._description.TransmissionCode)
                    {   
                        this._transmission = trns[i];
                        this._transmission.Vehicles.Add(this);
                        break;
                    }
                }
            }
            int yearCount = this._description.Sales.Length;
            int slMsrpYrs = 0;
            for (int i = 0; i < yearCount; i++)
            {
                if (this._description.Sales[i] > 0 && this._description.Msrp[i] > 0) { slMsrpYrs++; }
            }
            this._validYears = new ModelYear[slMsrpYrs];
            for (int i = 0, j = 0; i < yearCount; i++)
            {
                bool isValid = (this._description.Sales[i] > 0 && this._description.Msrp[i] > 0);
                if (isValid) { this._validYears[j++] = new ModelYear(i + ModelYear.MinYear); }
            }
            bool isElcOrHgnOnly = (this._description.FuelEconomy.PrimaryFuel == FuelType.Electricity ||
                this._description.FuelEconomy.PrimaryFuel == FuelType.Hydrogen);
            bool isStrongHEV = false;
            if (this._modelData.TechUsed != null)
            {
                for (int i = 0; i < TechnologyIndexes.TechnologyCount; i++)
                {
                    if (this._modelData.TechUsed[i])
                    {
                        if (TechnologyIndexes.IsHybridization(i)) { isStrongHEV = true; }
                        if (TechnologyIndexes.IsPureElectric(i) || TechnologyIndexes.IsHydrogenBased(i)) { isElcOrHgnOnly = true; }
                    }
                }
            }
            for (int i = 0; i < this._description.UsedTechnologies.Length; i++)
            {
                if (TechnologyIndexes.IsHybridization(this._description.UsedTechnologies[i])) { isStrongHEV = true; }
                if (TechnologyIndexes.IsPureElectric (this._description.UsedTechnologies[i]) ||
                    TechnologyIndexes.IsHydrogenBased(this._description.UsedTechnologies[i])) { isElcOrHgnOnly = true; }
            }
            if (!isElcOrHgnOnly)
            {
                string hdr = "Vehicle (Code:" + this._description.Code + ",Mfr:" + this._description.Manufacturer + "):  ";
                if (this._engine       == null                 ) { throw new Exception("\n\n" + hdr + "Engine Code is not valid."); }
                if (this._transmission == null  && !isStrongHEV) { throw new Exception("\n\n" + hdr + "Transmission Code is not valid."); }
            }
            this.AssignStyle();
            this.AssignTypeAndMobile6Class();
            this.AssignTechnologyClass();
            this.AssignSafetyClass();
        }
        void AssignStyle()
        {
            switch (this._description.Style.ToUpper())
            {
                case "CONVERTIBLE"  : this._vehicleStyle = VehicleStyle.Convertible;  break;
                case "COUPE"        : this._vehicleStyle = VehicleStyle.Coupe;        break;
                case "HATCHBACK"    : this._vehicleStyle = VehicleStyle.Hatchback;    break;
                case "SEDAN"        : this._vehicleStyle = VehicleStyle.Sedan;        break;
                case "WAGON"        : this._vehicleStyle = VehicleStyle.Wagon;        break;
                case "MINIVAN"      : this._vehicleStyle = VehicleStyle.Minivan;      break;
                case "VAN"          : this._vehicleStyle = VehicleStyle.Van;          break;
                case "SPORT UTILITY": this._vehicleStyle = VehicleStyle.SportUtility; break;
                case "PICKUP"       : this._vehicleStyle = VehicleStyle.Pickup;       break;
                default             : this._vehicleStyle = VehicleStyle.None;         break;
            }
        }
        void AssignTypeAndMobile6Class()
        {
            string style  = this._description.Style;
            double gvwr   = this._description.GVWR;
            double weight = this._description.CurbWeight;
            bool   isDom  = (this._description.Origin == 'D');
            if (this._vehicleStyle == VehicleStyle.Convertible || this._vehicleStyle == VehicleStyle.Coupe ||
                this._vehicleStyle == VehicleStyle.Hatchback   || this._vehicleStyle == VehicleStyle.Sedan ||
                this._vehicleStyle == VehicleStyle.Wagon)
            {   
                this._vehicleType = VehicleType.PassengerAuto;
                this._mobile6Class = Mobile6Class.LDV;
            }
            else
            {
                if (gvwr > 8500 || weight > 6000)
                {   
                    this._vehicleType = VehicleType.HeavyLT;
                    this._mobile6Class = Mobile6Class.HDV;
                }
                else
                {   
                    this._vehicleType = VehicleType.LightTruck;
                    this._mobile6Class = (gvwr <= 6000) ? Mobile6Class.LDT1 : Mobile6Class.LDT2;
                }
            }
            this._vehicleType |= ((isDom) ? VehicleType.Domestic : VehicleType.Imported);
        }
        void AssignTechnologyClass()
        {
            string[] techClasses =
                new string[] {
                                 "SUBCOMPACT PC", "SUBCOMPACT PERF. PC", "COMPACT PC", "COMPACT PERF. PC",
                                 "MIDSIZE PC"   , "MIDSIZE PERF. PC"   , "LARGE PC"  , "LARGE PERF. PC"  ,
                                 "MINIVAN LT"   , "SMALL LT"           , "MIDSIZE LT", "LARGE LT"
                             };
            this._techClass = TechnologyClass.None;
            for (int i = 0; i < techClasses.Length; i++)
            {
                if (Interaction.StringCompare(this._description.TechnologyClass, techClasses[i], true))
                {
                    this._techClass = (TechnologyClass)(i + 1);
                }
            }
        }
        void AssignSafetyClass()
        {
            this._safetyClass = SafetyClass.None;
            if      (Interaction.StringCompare(this._description.SafetyClass, "PC", true)) { this._safetyClass = SafetyClass.PC; }
            else if (Interaction.StringCompare(this._description.SafetyClass, "LT", true)) { this._safetyClass = SafetyClass.LT; }
            else if (Interaction.StringCompare(this._description.SafetyClass, "CM", true)) { this._safetyClass = SafetyClass.CM; }
        }
        internal void SetEngine(Engine engine)
        {
            this._engine = engine;
            this._description.EngineCode = engine.Description.Code;
        }
        internal void SetTransmission(Transmission transmission)
        {
            this._transmission = transmission;
            this._description.TransmissionCode = transmission.Description.Code;
        }
        internal void SetNamePlate(NamePlate namePlate)
        {
            this._namePlate = namePlate;
        }
        public void RemoveEngine()
        {
            if (this._engine != null)
            {   
                this._legacyEng = this._engine.Description.Clone();
                this._description.ElectricPower = this._legacyEng.Horsepower;
                this._engine.RemoveVehicle(this);
                this._description.EngineCode = -1;
                this._engine = null;
            }
        }
        public void RemoveTransmission()
        {
            if (this._transmission != null)
            {   
                this._legacyTrn = this._transmission.Description.Clone();
                this._transmission.RemoveVehicle(this);
                this._description.TransmissionCode = -1;
                this._transmission = null;
            }
        }
        public void GetRedesignState(ModelYear modelYear, out bool atRedesign, out bool inShadowOfRedesign)
        {
            atRedesign = inShadowOfRedesign = false;    
            int year = modelYear.Year;
            int[] redesignYears = this._description.RedesignYears;
            for (int i = 0, count = redesignYears.Length; i < count; i++)
            {
                if (redesignYears[i] == year) { atRedesign = true; break; }
            }
            if (!atRedesign)
            {
                for (int i = 0, count = redesignYears.Length; i < count; i++)
                {
                    int delta = Math.Abs(redesignYears[i] - year);    
                    if (0 < delta && delta < 5) { inShadowOfRedesign = true; break; }
                }
            }
        }
        public void GetRefreshState(ModelYear modelYear, out bool atRefresh, out bool inShadowOfRefresh)
        {
            atRefresh = inShadowOfRefresh = false;
            int year = modelYear.Year;
            int[] refreshYears = this._description.RefreshYears;
            for (int i = 0, count = refreshYears.Length; i < count; i++)
            {
                if (refreshYears[i] == year) { atRefresh = true; break; }
            }
            if (!atRefresh)
            {
                for (int i = 0, count = refreshYears.Length; i < count; i++)
                {
                    int delta = Math.Abs(refreshYears[i] - year);    
                    if (0 < delta && delta < 2) { inShadowOfRefresh = true; break; }
                }
            }
        }
        public double CalcLaborHours(ModelYear year)
        {
            return this.CalcLaborHours(year.Index);
        }
        public double CalcLaborHours(ModelYear minYear, ModelYear maxYear)
        {
            double hours = 0;
            for (int i = minYear.Index; i <= maxYear.Index; i++)
            {
                hours += this.CalcLaborHours(i);
            }
            return hours;
        }
        double CalcLaborHours(int yrIndex)
        {
            return this._description.EmploymentHours * this._description.Sales[yrIndex] / 1000;
        }
        #endregion
        #region 
        public Vehicle.CDescription Description { get { return this._description; } }
        public Vehicle.CModelData ModelData { get { return this._modelData; } }
        public Manufacturer Manufacturer { get { return this._manufacturer; } }
        public Engine Engine { get { return this._engine; } }
        public Transmission Transmission { get { return this._transmission; } }
        public NamePlate NamePlate { get { return this._namePlate; } }
        public Engine.CDescription LegacyEng { get { return this._legacyEng; } }
        public Transmission.CDescription LegacyTrn { get { return this._legacyTrn; } }
        public RegulatoryClass RegClass { get { return this._regClass; } set { this._regClass = value; } }
        public bool IsRCAuto { get { return (this._regClass == RC.DomesticAuto || this._regClass == RC.ImportedAuto); } }
        public bool IsRCTruck { get { return (this._regClass == RC.LightTruck); } }
        public TechnologyClass TechnologyClass { get { return this._techClass; } }
        public Mobile6Class Mobile6Class { get { return this._mobile6Class; } }
        public SafetyClass SafetyClass { get { return this._safetyClass; } }
        public VehicleType VehicleType { get { return this._vehicleType; } }
        public VehicleStyle VehicleStyle { get { return this._vehicleStyle; } }
        public bool IsAuto { get { return (this._vehicleType & VehicleType.PassengerAuto) == VehicleType.PassengerAuto; } }
        public bool IsTruck { get { return !this.IsAuto; } }
        public HEVType HEVType { get { return this._hevType; } set { this._hevType = value; } }
        public ModelYear[] ValidYears { get { return this._validYears; } }
        public ModelYear MinYear { get { return (this._validYears == null) ? null : this._validYears[0]; } }
        public ModelYear MaxYear { get { return (this._validYears == null) ? null : this._validYears[this._validYears.Length - 1]; } }
        #endregion
        #region 
        Vehicle.CDescription _description;
        Vehicle.CModelData   _modelData;
        Manufacturer              _manufacturer;
        Engine                    _engine;
        Transmission              _transmission;
        NamePlate                 _namePlate;
        Engine      .CDescription _legacyEng;
        Transmission.CDescription _legacyTrn;
        RegulatoryClass _regClass;
        TechnologyClass _techClass;
        Mobile6Class    _mobile6Class;
        SafetyClass     _safetyClass;
        VehicleType     _vehicleType;   
        VehicleStyle    _vehicleStyle;
        HEVType _hevType;
        ModelYear[] _validYears;    
        #endregion
    }
}

