using System;
namespace Volpe.Cafe.Model
{
    public sealed class FunctionInformation
    {
        #region 
        public static bool IsSupportedFunction(int fncType)
        {
            return ((fncType >= 1 && fncType <= 9) || fncType == 99 || fncType == 206 || fncType == 207);
        }
        public static bool IsFlatStandard(int fncType)
        {
            return (fncType == 1 || fncType == 99);
        }
        public static bool IsLogisticFunction(int fncType)
        {
            return (fncType == 2 || fncType == 4);
        }
        public static bool IsExponentialFunction(int fncType)
        {
            return (fncType == 3 || fncType == 5);
        }
        public static bool IsLinearFunction(int fncType)
        {
            return (fncType >= 6 && fncType <= 9 || fncType == 206 || fncType == 207);
        }
        public static bool IsAreaBasedFunction(int fncType)
        {
            return (fncType == 2 || fncType == 3 || fncType == 6 || fncType == 8 || fncType == 206);
        }
        public static bool IsWeightBasedFunction(int fncType)
        {
            return (fncType == 4 || fncType == 5 || fncType == 7 || fncType == 9 || fncType == 207);
        }
        public static int GetCoefficientCount(int fncType)
        {
            if      (fncType == 1 || fncType == 99                                   ) { return 1; }
            else if (fncType == 2 || fncType == 4 || fncType ==   6 || fncType ==   7) { return 4; }
            else if (fncType == 3 || fncType == 5 || fncType ==   8 || fncType ==   9) { return 3; }
            else if (                                fncType == 206 || fncType == 207) { return 8; }
            else                                                                       { return -1; }
        }
        public static string[] GetCoefficientNames(int fncType)
        {
            if      (fncType == 1 || fncType == 99                                   ) { return new string[] {"A"}; }
            else if (fncType == 2 || fncType == 4 || fncType ==   6 || fncType ==   7) { return new string[] {"A", "B", "C", "D"}; }
            else if (fncType == 3 || fncType == 5 || fncType ==   8 || fncType ==   9) { return new string[] {"A", "B", "C"}; }
            else if (                                fncType == 206 || fncType == 207) { return new string[] {"A", "B", "C", "D", "E", "F", "G", "H"}; }
            else                                                                       { return null; }
        }
        #endregion
    }
}

