using System;
namespace Volpe.XlLib
{
    [Serializable]
    public class XlRange
    {
        #region 
        public XlRange(XlCell cell1, XlCell cell2)
        {
            this.Cell1 = cell1;
            this.Cell2 = cell2;
        }
        public XlRange(int row1, int column1, int row2, int column2)
        {
            this.Cell1 = new XlCell(row1, column1);
            this.Cell2 = new XlCell(row2, column2);
        }
        #endregion
        #region 
        public override string ToString()
        {
            return ("{" + this.Cell1.ToString() + ", " + this.Cell2.ToString() + "}");
        }
        #endregion
        #region 
        public bool IsEmpty { get { return (this.Cell1.IsEmpty && this.Cell2.IsEmpty); } }
        public bool IsValid { get { return (this.Cell1.IsValid && this.Cell2.IsValid); } }
        #endregion
        #region 
        public static readonly XlRange Empty = new XlRange(0, 0, 0, 0);
        public XlCell Cell1;
        public XlCell Cell2;
        #endregion
    }
}

