#region << Using Directives >>
using System;
using System.Globalization;
#endregion
namespace Volpe.XlLib
{
    class Information
    {
        #region 
        public static bool IsNumeric(string value)
        {
            double d;
            return double.TryParse(value, NumberStyles.Any, NumberFormatInfo.InvariantInfo, out d);
        }
        public static bool IsNumeric(object value)
        {
            return Information.IsNumeric(Information.GetStringInternal_NoCaseConversion(value));
        }
        public static double GetDouble(string value)
        {
            double d = 0;
            double.TryParse(value, NumberStyles.Any, NumberFormatInfo.InvariantInfo, out d);
            return d;
        }
        public static double GetDouble(object value)
        {
            return Information.GetDouble(Information.GetStringInternal_NoCaseConversion(value));
        }
        public static string GetString(object value)
        {
            return GetStringInternal_NoCaseConversion(value).ToUpper();
        }
        static string GetStringInternal_NoCaseConversion(object value)
        {
            return (value == null) ? string.Empty : value.ToString().Trim();
        }
        #endregion
    }
}

